/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************
 Beach Region.sc
 Contains the beach region for use with all the rooms that have water that Ego 
 can walk in.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 700)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
(use "menubar")
/******************************************************************************/
(instance public beachRegion of Rgn
	(properties)
	(method (init)
		(super:init())
	    (self:setScript(beachRegionScript))
    )
)
/******************************************************************************/
(instance beachRegionScript of Script
	(properties)
	(method (doit)
		(super:doit())
		(if (== (send gEgo:onControl()) ctlGREEN)
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoWading gEgoWading))
		)
		(if (== (send gEgo:onControl()) (| ctlTEAL ctlGREEN))
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (& (send gEgo:onControl()) ctlTEAL)
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (== (send gEgo:onControl()) (| ctlTEAL ctlMAROON))
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (& (send gEgo:onControl()) ctlMAROON)
			(send gEgo:setCycle(StopSwim gEgoSwimming gEgoSwimming))
		)
		(if (& (send gEgo:onControl()) ctlNAVY)
			(if (== gEgoIsSwimming FALSE)
				= gEgoIsSwimming TRUE
			)
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) (| ctlNAVY ctlGREEN))
			(if (== gEgoIsSwimming FALSE)
				= gEgoIsSwimming TRUE
			)
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) ctlBLACK)
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
			(if (== gEgoIsSwimming TRUE)
				= gEgoIsSwimming FALSE
			)
		)
    )
 
    (method (handleEvent pEvent)
        (super:handleEvent(pEvent))
        (if(Said('look>'))
        	(if(Said('/rock'))
            	Print(700 0)
        	)
        	(if(Said('/(palm<tree) , tree'))
	            Print(700 1)
        	)
        	(if(Said('/wave'))
	            Print(700 2)
        	)
        	(if(Said('/water'))
	            Print(700 3)
        	)
        	(if(Said('/plant'))
	            Print(700 4)
        	)
        	(if(Said('/flower'))
	            Print(700 5)
        	)
        	(if(Said('/sky'))
	            Print(700 6)
        	)
        	(if(Said('[/around,sand]'))
	            Print(700 7)
        	)
		)
        (if(Said('get>'))
        	(if(Said('/sand'))
            	Print(700 9)
        	)
        	(if(Said('/flower'))
	            Print(700 10)
        	)
        	(if(Said('/rock'))
	            Print(700 12)
        	)
        	(if(Said('/cloth'))
        		(if (send gEgo:has(INV_BOTTLE))
        			Print("You pull a large piece of cloth out of the bottle.")
					(send gEgo:put(INV_BOTTLE)get(INV_EMPTYBOTTLE)get(INV_CLOTH))
				)(else
					(if (send gEgo:has(INV_CLOTH))
						Print("You already have the cloth.")
					)(else
						Print("You can't get that.")
					 )
				 )
			)
		)
		(if(Said('climb>'))
			(if(Said('/tree'))
				Print(700 14)
			)
			(if(Said('/rock'))
				Print(700 15)
			)
			(if(Said('/(flower,bush,sand)'))
				Print(700 16)
			)
		)
		(if(Said('drink/water'))		
			(if (<> (send gEgo:onControl()) ctlBLACK)
				Print(700 17)
			)(else
				Print(700 18)
			 )
		)
    )
)
/******************************************************************************/
(instance ankleWater of Prop
    (properties
        x 0
        y 0
        view 2
        cel 0
	)
    (method (init)
        (super:init())
        (self:z(89))
        (self:setScript(anklewaterScript))
    )
)
 
(instance anklewaterScript of Script
    (properties)
    (method (doit)
        (ankleWater:
            posn((send gEgo:x) (- (send gEgo:y) -90))
            setPri(send gEgo:priority)
		)
        (super:doit())
	)
)