/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************
 Fishing Region.sc
 Contains the fishing region for use with all the rooms that Ego can fish with
 the fishing net to catch the exotic fish in the tower realm.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 704)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(local
	lFishSuccess
	lCaughtFish = FALSE
	lFishLifeTimer = 0
	lFishDead = FALSE
	lHelpedFish = FALSE
	lGreenStepped = FALSE
)
/******************************************************************************/
(instance public fishingRegion of Rgn
	(properties)
	(method (init)
		(super:init())
	    (self:setScript(fishingRegionScript))
	    (if(send gEgo:has(INV_GASPFISH))
	    	= lCaughtFish TRUE
	    	= lFishLifeTimer 200
		)
    )
)
/******************************************************************************/
(instance fishingRegionScript of Script
	(properties)
	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(> lFishLifeTimer 0 and == lCaughtFish TRUE)
			--lFishLifeTimer
		)
		(if(== lFishLifeTimer 0)
			(if(== lCaughtFish TRUE and == lFishDead FALSE and == lHelpedFish FALSE)
				(if(not (send gEgo:has(INV_GASPFISH)))
					Print("Oh, dear, the beautiful golden fish has died. What a pity.")
					= lFishDead TRUE
					(aFish:
						setCycle(End)
						setLoop(2)
					)
				)(else
					Print("Oh, dear, the beautiful fish has died. With a mighty heave, you throw the dead fish back into the sea. Slowly, it sinks to the bottom.")
					= lCaughtFish FALSE
					(send gEgo:put(INV_GASPFISH))
				 )
			)
		)
		(if(== (send gEgo:onControl()) ctlNAVY and == lGreenStepped FALSE)
			= lGreenStepped TRUE
			(aFish:setScript(swimmingScript))
		)
	)
	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))
        // handle Said's, etc...
        (if(Said('fish'))
        	(if(send gEgo:has(INV_NET))
        		(if(== (send gEgo:onControl()) ctlGREEN)
        			(if(== lCaughtFish FALSE)
        				= lFishSuccess Random(0 1)
        				(if(== lFishSuccess 1)
        					Print("You cast the fishing net into the wild sea. Upon retrieving it, you see you have caught a large golden fish! It falls from the net and flops helplessly on the beach.")        					
        					= lCaughtFish TRUE
        					(aFish:
        						init()
        						setLoop(0)
        						setCycle(Fwd)
        					)
        					= lFishLifeTimer 100
						)(else
							Print("You fish, and fish, and fish ... However, no matter how hard you try, you don't seem to be able to catch anything.")
					 	)
					)(else
						Print("You fish, and fish, and fish ... However, no matter how hard you try, you don't seem to be able to catch anything.")
					 )
				)(else
					Print("You're not close enough to the water to fish.")
				 )
			)(else
				Print("You don't have anything to fish with.")
			 )
		)
        (if(Said('use/net[/water]'))
        	(if(send gEgo:has(INV_NET))
        		(if(== (send gEgo:onControl()) ctlGREEN)
        			(if(== lCaughtFish FALSE)
        				= lFishSuccess Random(0 2)
        				(if(== lFishSuccess 1)
        					Print("You cast the fishing net into the wild sea. Upon retrieving it, you see you have caught a large golden fish! It falls from the net and flops helplessly on the beach.")        					
        					= lCaughtFish TRUE
        					(aFish:
        						init()
        						setLoop(0)
        						setCycle(Fwd)
        					)
        					= lFishLifeTimer 100
						)(else
							Print("You fish, and fish, and fish ... However, no matter how hard you try, you don't seem to be able to catch anything.")
					 	)
					)(else
						Print("You fish, and fish, and fish ... However, no matter how hard you try, you don't seem to be able to catch anything.")
					 )
				)(else
					Print("You're not close enough to the water to fish.")
				 )
			)(else
				Print("You don't have anything to fish with.")
			 )
		)
		(if(Said('get>'))
			(if(Said('/fish'))
				(if(<= send gEgo:distanceTo(aFish) 15)
					(if(== lFishDead FALSE)
						Print("You grab the flopping fish. Its mouth is wide open and its gills are extended. With difficulty, you hold the fish as it twists and turns in your hands.")
						(send gEgo:get(INV_GASPFISH))
						(aFish:dispose())
						= lFishLifeTimer 300
					)(else
						Print("Holding your nose, you pick up the dead, stinking fish. Yucchhhh! With a mighty heave, you throw the fish back into the sea. Slowly, it sinks to the bottom.")
						= lCaughtFish FALSE
						= lFishDead FALSE
						(aFish:dispose())
					 )
				)(else
					PrintNotCloseEnough()
				 )
			)
		)
		(if(Said('throw/fish[/water]'))
			(if(send gEgo:has(INV_GASPFISH))
				(if(== lFishDead FALSE)
					(if(== (send gEgo:onControl()) ctlGREEN)
						Print("You throw the poor gasping fish back into the iridescent water. Gratefully, it calls to you, \"In return for saving my life, I wish to offer you a ride across this ocean.\"")
						(send gGame:changeScore(3))
						(aFish:							
							posn(245 120)
							setLoop(1)
							setCycle(Fwd)
							init()
							ignoreActors()
						)
						= lHelpedFish TRUE
					)(else
						Print("You're not close enough to the water.")
					 )
				)
			)(else
				PrintDontHaveIt()
			 )
		)
		(if(Said('kill/fish'))
			(if(not (send gEgo:has(INV_GASPFISH)))
				(if(== lCaughtFish TRUE)
					(if(== lFishDead FALSE)
						(if(<= send gEgo:distanceTo(aFish) 15)
							(if(send gEgo:has(INV_SWORD))
								Print("You plunge your sword into the writhing fish, instantly killing it!")
								= lFishDead TRUE
							)(else
								Print("You don't have anything to kill it with.")
							 )
						)(else
							PrintNotCloseEnough()
						 )
					)(else
						Print("The fish is already dead.")
					 )
				)(else
					PrintDontSeeIt()
				 )
			)(else
				Print("You don't need to kill the golden fish. It will die shortly anyway.")
			 )
		)
	)
	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance aFish of Prop
	(properties
		x 150
		y 135
		view 37
	)
)
(instance aRideFish of Act
	(properties
		view 38
	)
)
(instance swimmingScript of Script
	(properties)
	(method (changeState newState)
	(var dyingScript)
		= state newState
		(switch(state)
			(case 0
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide())
				(if(== lHelpedFish TRUE)					
					(aFish:dispose())
					(swimmingScript:cue())					
				)(else
					(if(send gEgo:has(INV_GASPFISH))
						(send gEgo:put(INV_GASPFISH))
						(swimmingScript:cue())
					)(else
						(swimmingScript:changeState(3))
					 )
				 )
			)
			(case 1
				(send gGame:changeScore(1))
				(aRideFish:
					posn(245 120)
					init()
					setCycle(Fwd)
					setStep(7 7)
					setMotion(MoveTo 319 120 swimmingScript)
				)
			)
			(case 2
				= gDefaultPalette 1
				(send gRoom:newRoom(76))
			)
			(case 3
				Print("The water is just too turbulent to swim in. You have just drowned.")
				(swimmingScript:cue())
			)
			(case 4
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("Thank you for playing King's Quest II. I'm sure Ken and Roberta Williams would have appreciated it, had they created this remake in Sierra's heyday.")
				)
  				(send gGame:setScript(dyingScript))
			)
		)
	)	
)