/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script INTRO_SCRIPT)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "DPath")
/******************************************************************************/
(instance public Intro1 of Rm
	(properties
		picture 104
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(send gGame:setSpeed(8))
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(52 140)
					loop(0)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(SitStand:init())
		(Mirror:init())
		(theHat:init())
		(Stand:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
//		(var yStart, xStart, yFinish, xFinish, w, h, w2, h2, x, y, hCenter, vCenter)
		= state newState
		(switch(state)
			(case 0 
				(= cycles 1)
			)
			(case 1 = cycles 5
				SetCursor(997 FALSE)//(send gGame:setCursor(997 0))
				ProgramControl()
				= gProgramControl TRUE
			)
			(case 2 = cycles 65
				Print(104 0 #dispose #width 234 #at (/ (- 320 234) 2) 143 #time 9)
			)
			(case 3 = cycles 65
				Print(104 1 #dispose #width 234 #at (/ (- 320 234) 2) 143 #time 9)				
			)
			(case 4 = cycles 45
				Print(104 2 #dispose #width 234 #at (/ (- 320 234) 2) 149 #time 7)				
			)
			(case 5
				(send gGame:setSpeed(6))
				(SitStand:setCycle(End RoomScript))
			)
			(case 6
				(send gGame:setSpeed(8))
				Print(104 3 #dispose #width 234 #at (/ (- 320 234) 2) 149 #time 9)
				(SitStand:hide())
				(crownEgo:init()setCycle(StopWalk 6 7)
					setMotion(
						DPath 
						142 126 
						154 103 
						RoomScript
					)
				)
			)
			(case 7 = cycles 1
				(crownEgo:setCycle(StopWalk 6 7)loop(3))
			)
			(case 8 = cycles 40				
				(Mirror:loop(1)setCycle(Fwd))
			)
			(case 9
				(send gRoom:newRoom(107))
			)
		)
	)
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)(else
				(if (== (send pEvent:message) KEY_RETURN)
					(send gRoom:newRoom(TITLESCREEN_SCRIPT))
				)
			 )
		)	
		(if(== (send pEvent:type()) evMOUSEBUTTON)
			(send gRoom:newRoom(TITLESCREEN_SCRIPT))
		)
	)
)
/******************************************************************************/
(instance shimmerScript of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 1
                 (Mirror:setCycle(End shimmerScript))
            )(case 2
                 (Mirror:setCycle(Beg shimmerScript)) 
            )(case 3
                 (shimmerScript:changeState(1)) // make it all loop around forever!
			 )
		)
	)
)
(instance SitStand of Act
	(properties
		x 83
		y 117
		view 9
		cycleSpeed 1
	)
)
(instance crownEgo of Act
	(properties
		x 83
		y 117
		view 6
	)
)
(instance Mirror of Prop
	(properties
		x 158
		y 46
		view 10
		loop 0
		cel 0
	)
)
(instance theHat of Prop
	(properties
		x 52
		y 137
		z 24
		view 11
		loop 1
		cel 0
	)
)
(instance Stand of Prop
	(properties
		x 52
		y 137
		view 11
		loop 0
		cel 0
	)
)