/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
(include "keys.sh")
/******************************************************************************/
(script TITLESCREEN_SCRIPT)
/******************************************************************************/
(use "main")
(use "game")
(use "menubar")
(use "obj")
(use "cycle")
(use "user")
(use "controls")
(use "feature")

(local
    title1 = 0
	title2 = 0
	sIntro = 1
	sBegin = 0
	sCred = 0
	sCont = 0
	sMenuStart = 0
)
/******************************************************************************/
(instance public TitleScreen of Rm
	(properties
		picture scriptNumber
	)
	(method (init)
        // Set up the title screen
		ProgramControl()
		= gProgramControl TRUE
		(send gGame:setSpeed(4))
		(SL:disable())
		(TheMenuBar:hide())

		(super:init())
		(self:setScript(RoomScript))

		(send gEgo:init()hide())
		
        (theRomance:init())
        (theThrone:init())
		//(send gTheMusic:prevSignal(0)stop()number(1)loop(0)play())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (changeState newState)
        = state newState
	  	(switch(state)
            (case 0 
				(= cycles 1)
            )(case 1 = cycles 80
                (theSpark1:init()setCycle(Fwd))
		       	(theSpark2:init()setCycle(Fwd))
		        (theSpark3:init()setCycle(Fwd))
		        (theSpark4:init()setCycle(Fwd))
		        (theSpark5:init()setCycle(Fwd))
		        (theSpark6:init()setCycle(Fwd))
		        (theSpark7:init()setCycle(Fwd))
		        (theSpark8:init()setCycle(Fwd))
                (send gTheMusic:prevSignal(0)stop()number(1)loop(0)play())
                SetCursor(999 HaveMouse())                
                = title1 Display("SCI Pre-Alpha Version"
                    dsCOORD 0 170
                    dsALIGN alCENTER
                    dsWIDTH 320
                    dsCOLOUR clWHITE
                    dsBACKGROUND clTRANSPARENT
                    dsFONT 4
                    dsSAVEPIXELS
				)
                = title2 Display("By: Brandon Blume"
                    dsFONT 4
                    dsCOORD 0 180
                    dsWIDTH 320
                    dsALIGN alCENTER
                    dsCOLOUR clWHITE
                    dsBACKGROUND clTRANSPARENT
                    dsSAVEPIXELS
                )
            )(case 2 = cycles 15
                (theRomance:hide())
                (theThrone:hide())
                = title1 Display("" dsRESTOREPIXELS title1)
                = title2 Display("" dsRESTOREPIXELS title2)
    	    )(case 3
                (send gGame:setCursor(999 1))
                = sMenuStart 1
                (theRomance:dispose())
                (theThrone:dispose())
                = title1 Display("" dsRESTOREPIXELS title1)
                = title2 Display("" dsRESTOREPIXELS title2)
            
                (buttonIntro:init()loop(1)setScript(pressIntro))
                (buttonBegin:init()loop(2)setScript(pressBegin))
                (buttonCred:init()loop(3)setScript(pressCred))
                (buttonCont:init()loop(4)setScript(pressCont))
                (if (sIntro)
                	(buttonSelect:init()loop(5)posn(58 146))
				)(else
					(if (sBegin)
						(buttonSelect:init()loop(5)posn(161 146))
					)(else
						(if (sCred)
							(buttonSelect:init()loop(5)posn(58 165))
						)(else
							(if (sCont)
								(buttonSelect:init()loop(5)posn(161 165))
							)
						 )
					 )
				 )
			 )
        )
	)

	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))
        (if (==(send pEvent:type)evKEYBOARD)
        	(if(==(send pEvent:message)KEY_RETURN)
           		(if(sMenuStart)
           			(if(sBegin)
            			(send gTheMusic:fade())
            			(send gRoom:newRoom(INITROOMS_SCRIPT))
               		)(else
		                (if(sCont)
    	                   	(send gGame:restore())
                   		)(else
		                   	(if(sIntro)
    	                   		= gIntro 1
                           		(send gTheMusic:fade())
           	               		(send gRoom:newRoom(INTRO_SCRIPT))
               	       		)(else
	                   	       	(if(sCred)
                               		= gCred 1
                       	    		(send gTheMusic:fade())
                           			(send gRoom:newRoom(INTROCREDITS_SCRIPT))
								)
							 )
						 )
					 )
				)(else
					(RoomScript:changeState(3))
				 )				 
			)(else
				(if(sMenuStart)
					Print("Use the arrow keys then enter or mouse to select option.")
				)
			 )
		)
		(if(==(send pEvent:type) evJOYSTICK)
            (if (sMenuStart)
            	(if(==(send pEvent:message) 1)  // UP
	                selectorCheckUp()
    	        )
			)
        )
        (if(==(send pEvent:type) evJOYSTICK)
            (if (sMenuStart)
            	(if(==(send pEvent:message) 5)  // Down
                	selectorCheckDown()
            	)
			)
        )		
        (if(==(send pEvent:type) evJOYSTICK)
            (if (sMenuStart)
            	(if(==(send pEvent:message) 7)  // Left
                	selectorCheckLeft()
            	)
			)
        )
        (if(==(send pEvent:type) evJOYSTICK)
            (if (sMenuStart)
            	(if(==(send pEvent:message) 3)  // Right
                	selectorCheckRight()
            	)
			)
        )        
		(if(==(send pEvent:type())evMOUSEBUTTON)
            (if(sMenuStart)
                (if((> (send pEvent:x) (buttonBegin:nsLeft))and
                    (< (send pEvent:x) (buttonBegin:nsRight))and
                    (> (send pEvent:y) (buttonBegin:nsTop))and
                    (< (send pEvent:y) (buttonBegin:nsBottom)))
                    (if(sBegin)
                    	selectorZero()
                    	= sBegin 1
                        (send gTheMusic:fade())
                        (send gRoom:newRoom(INITROOMS_SCRIPT))
                    )(else
						(pressBegin:changeState(2))
                	)

        	    )(else
                    (if((> (send pEvent:x) (buttonCont:nsLeft))and
                        (< (send pEvent:x) (buttonCont:nsRight))and
                	    (> (send pEvent:y) (buttonCont:nsTop))and
                	    (< (send pEvent:y) (buttonCont:nsBottom)))
                	    (if(sCont)
                	    	selectorZero()
                	    	= sCont 1
                    	    (send gGame:restore())
                	    )(else
                            (pressCont:changeState(2))
                	    )
            	    )(else
                        (if((> (send pEvent:x) (buttonCred:nsLeft))and
                            (< (send pEvent:x) (buttonCred:nsRight))and
                            (> (send pEvent:y) (buttonCred:nsTop))and
                            (< (send pEvent:y) (buttonCred:nsBottom)))
                            (if(sCred)
                            	selectorZero()
                                = gCred 1
                        	   (send gTheMusic:fade())
                        	   (send gRoom:newRoom(INTROCREDITS_SCRIPT))
                    	    )(else
                        	    (pressCred:changeState(2))
                    	    )
                	    )(else
                            (if((> (send pEvent:x) (buttonIntro:nsLeft))and
                                (< (send pEvent:x) (buttonIntro:nsRight))and
                                (> (send pEvent:y) (buttonIntro:nsTop))and
                        	    (< (send pEvent:y) (buttonIntro:nsBottom)))
                        	    (if(sIntro)
                        	    	selectorZero()
                                    = gIntro 1
                            	    (send gTheMusic:fade())
                            	    (send gRoom:newRoom(INTRO_SCRIPT))
                        	    )(else
                            	    (pressIntro:changeState(2))
				                )
                            )(else
                            	Print("Use the arrow keys then enter or mouse to select option.")
							 )
                        )
                    )
				)
			)(else
                (RoomScript:changeState(3))
            )
        )
	)
)
/******************************************************************************/

/**********Menu Selector Procedures*************/

//Menu select UP
(procedure (selectorCheckUp)
    (if(sBegin)
        selectorZero()
        = sCred 1
        (buttonSelect:posn(58 165))
    )(else
        (if(sCont)
            selectorZero()
            = sBegin 1
            (buttonSelect:posn(161 146))
        )(else
            (if(sCred)
                selectorZero()
                = sIntro 1
                (buttonSelect:posn(58 146))
            )(else
                (if(sIntro)
                    selectorZero()
                    =sCont 1
                    (buttonSelect:posn(161 165))
                )
            )
        )
    )
)
//Menu select DOWN
(procedure (selectorCheckDown)
    (if(sBegin)
        selectorZero()
        = sCont 1
        (buttonSelect:posn(161 165))
    )(else
        (if(sCont)
            selectorZero()
            = sIntro 1
            (buttonSelect:posn(58 146))
        )(else
            (if(sCred)
                selectorZero()
                = sBegin 1
                (buttonSelect:posn(161 146))
            )(else
                (if(sIntro)
                    selectorZero()
                    = sCred 1
                    (buttonSelect:posn(58 165))
                )
            )
        )
    )
)
//Menu select LEFT
(procedure (selectorCheckLeft)
    (if(sBegin)
        selectorZero()
        = sIntro 1
        (buttonSelect:posn(58 146))
    )(else
        (if(sCont)
            selectorZero()
            = sCred 1
            (buttonSelect:posn(58 165))
        )(else
            (if(sCred)
                selectorZero()
                = sBegin 1
                (buttonSelect:posn(161 146))
            )(else
                (if(sIntro)
                    selectorZero()
                    = sCont 1
                    (buttonSelect:posn(161 165))
                )
            )
        )
    )
)
//Menu select RIGHT
(procedure (selectorCheckRight)
    (if(sBegin)
        selectorZero()
        = sCred 1
        (buttonSelect:posn(58 165))
    )(else
        (if(sCont)
            selectorZero()
            = sIntro 1
            (buttonSelect:posn(58 146))
        )(else
            (if(sCred)
                selectorZero()
                = sCont 1
                (buttonSelect:posn(161 165))
            )(else
                (if(sIntro)
                    selectorZero()
                    = sBegin 1
                    (buttonSelect:posn(161 146))
                )
            )
        )
    )
)
//Reset all menu buttons (for use when enabling a buttons variable)
(procedure (selectorZero)
	= sBegin 0
	= sCont 0
	= sCred 0
	= sIntro 0
)

/*************Mouse click on new button instances**************/
/************when selector is not currently on them************/

//Mouse click on Begin Game button
(instance pressBegin of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 2 = cycles 1
                  selectorZero()
                  = sBegin 1
				  (buttonSelect:posn(161 146))
			)
            (case 3
                  (send gTheMusic:fade())
                  (send gRoom:newRoom(INITROOMS_SCRIPT))
			)
		)
	)
)
//Mouse click on Introduction button
(instance pressIntro of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 2 = cycles 1
				selectorZero()
				= sIntro 1
				(buttonSelect:posn(58 146))
			)
            (case 3
            	(send gTheMusic:fade())
            	(send gRoom:newRoom(INTRO_SCRIPT))
			)
		)
	)
)
//Mouse click on Credits button
(instance pressCred of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 2 = cycles 1
				selectorZero()
				= sCred 1
				(buttonSelect:posn(58 165))
			)
            (case 3
                  (send gTheMusic:fade())
                  (send gRoom:newRoom(INTROCREDITS_SCRIPT))
			)
		)
	)
)
//Mouse click on Continue Game button
(instance pressCont of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 2 = cycles 3
				selectorZero()
				= sCont 1
				(buttonSelect:posn(161 165))
			)
            (case 3
				(send gGame:restore())
			)
		)
	)
)
//Forward then backward "Shimmer" animation
(instance shimmerScript of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 1
                 (theSpark1:setCycle(End shimmerScript))
            )(case 2
                 (theSpark1:setCycle(Beg shimmerScript))
            )(case 3
                 (shimmerScript:changeState(1)) // make it all loop around forever!
			 )
		)
	)
)
/***********Prop Instances***********/
(instance theRomance of Prop
    (properties
        x 86
        y 166
        view 913
        cel 0
    )
)
(instance theThrone of Prop
    (properties
        x 236
        y 162
        view 913
        cel 1
    )
)
(instance theSpark1 of Prop
    (properties
//      x 61				//KQ1
//      y 27				//KQ1
		x 67				//KQ4
		y 26				//KQ4
        view 950
        cycleSpeed 2
    )
)
(instance theSpark2 of Prop
    (properties
        x 97				//Both
        y 59				//Both
        view 950
        cycleSpeed 3
        cel 2
    )
)
(instance theSpark3 of Prop
    (properties
//      x 130				//KQ1
//      y 21				//KQ1
		x 142				//KQ4
		y 20				//KQ4
        view 950
        cycleSpeed 2
        cel 4
    )
)
(instance theSpark4 of Prop
    (properties
//      x 182				//KQ1
//      y 21				//KQ1
        x 187				//KQ4
        y 28				//KQ4
        view 950
        cycleSpeed 1
    )
)
(instance theSpark5 of Prop
    (properties
//      x 208				//KQ1
//		y 54				//KQ1
		x 213				//KQ4
        y 62				//KQ4
        view 950
        cycleSpeed 7
        cel 1
    )
)
(instance theSpark6 of Prop
    (properties
//      x 264				//KQ1
//      y 32				//KQ1
        x 268				//KQ4
        y 38				//KQ4
        view 950
        cycleSpeed 5
    )
)
(instance theSpark7 of Prop
    (properties
        x 143
        y 89
        view 950
        cycleSpeed 6
        cel 3
    )
)
(instance theSpark8 of Prop
    (properties
        x 174
        y 117
        view 950
        cycleSpeed 4
    )
)
(instance buttonIntro of Prop
    (properties
        x 58
        y 146
        view 950
    )
)
(instance buttonBegin of Prop
    (properties
        x 161
        y 146
        view 950
    )
)
(instance buttonCred of Prop
    (properties
        x 58
        y 165
        view 950
    )
)
(instance buttonCont of Prop
    (properties
        x 161
        y 165
        view 950
    )
)
(instance buttonSelect of Prop
    (properties
//      x 58
//      y 146
        view 950
    )
)