/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************
 Water Region.sc
 Contains the water region for use with all the rooms that have water that Ego
 can walk in.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 701)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
(use "menubar")
/******************************************************************************/
(instance public waterRegion of Rgn
	(properties)
	(method (init)
		(super:init())
	    (self:setScript(waterRegionScript))
    )
)
/******************************************************************************/
(instance waterRegionScript of Script
	(properties)
	(method (doit)
		(super:doit())
		(if (== (send gEgo:onControl()) ctlGREEN)
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoWading gEgoWading))
		)
		(if (== (send gEgo:onControl()) (| ctlTEAL ctlGREEN))
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (& (send gEgo:onControl()) ctlTEAL)
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (== (send gEgo:onControl()) (| ctlTEAL ctlMAROON))
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (& (send gEgo:onControl()) ctlMAROON)
			(send gEgo:setCycle(StopSwim gEgoSwimming gEgoSwimming))
		)
		(if (& (send gEgo:onControl()) ctlNAVY)
			(if (== gEgoIsSwimming FALSE)
				= gEgoIsSwimming TRUE
			)
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) (| ctlNAVY ctlBLACK))
			(if (== gEgoIsSwimming FALSE)
				= gEgoIsSwimming TRUE
			)
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) (| ctlNAVY ctlGREEN))
			(if (== gEgoIsSwimming FALSE)
				= gEgoIsSwimming TRUE
			)
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) ctlBLACK)
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
			(if (== gEgoIsSwimming TRUE)
				= gEgoIsSwimming FALSE
			)
		)
    )
 
    (method (handleEvent pEvent)
        (super:handleEvent(pEvent))
    )
)
/******************************************************************************/
(instance ankleWater of Prop
    (properties
        x 0
        y 0
        view 2
        cel 0
	)
    (method (init)
        (super:init())
        (self:z(89))
        (self:setScript(anklewaterScript))
    )
)
 
(instance anklewaterScript of Script
    (properties)
    (method (doit)
        (ankleWater:
            posn((send gEgo:x) (- (send gEgo:y) -90))
            setPri(send gEgo:priority)
		)
        (super:doit())
	)
)