/*************************************************************************
 * SCI Game Header
 * By Brian Provinciano
 *************************************************************************
 * Put all the defines specific to your game in here
 *************************************************************************/

// Base Scripts
(define MAIN_SCRIPT			  0)

(define AVOID_SCRIPT		973)
(define DOOR_SCRIPT		 	974)
(define AUTODOOR_SCRIPT		975)
(define INITROOMS_SCRIPT	976)
(define DYING_SCRIPT		977)
(define DISPOSELOAD_SCRIPT	978)
(define CONTROLS_SCRIPT		979)
(define DPATH_SCRIPT		980)
(define DCICON_SCRIPT		981)
(define REV_SCRIPT			982)
(define WANDER_SCRIPT		983)
(define FOLLOW_SCRIPT		984)
(define TIMER_SCRIPT		985)
(define WINDOW_SCRIPT		986)
(define GAUGE_SCRIPT		987)
(define EXTRA_SCRIPT		988)
(define SOUND_SCRIPT		989)
(define SYSWINDOW_SCRIPT	990)
(define JUMP_SCRIPT			991)
(define CYCLE_SCRIPT		992)
(define FILEIO_SCRIPT		993)
(define GAME_SCRIPT			994)
(define INVENTORY_SCRIPT	995)
(define USER_SCRIPT			996)
(define MENUBAR_SCRIPT		997)
(define FEATURE_SCRIPT		998)
(define OBJ_SCRIPT			999)

// Game Scripts
(define INTRO_SCRIPT		104)
(define SQDEMO_SCRIPT		111)
(define TITLESCREEN_SCRIPT	800)
(define INTROCREDITS_SCRIPT	801)

// Defaults
(define NORMAL_SPEED		  8)

// Sounds
(define DUMMY_SOUND           1)
(define SCORE_SOUND         900)
(define DEATH_SOUND           2)

// Inventory Items
(define INV_NOTHING           0)
(define INV_SWORD		      1)
(define INV_TRIDENT		      2)
(define INV_BOUQUET		      3)
(define INV_BRACELET	      4)
(define INV_STAKE		      5)
(define INV_RING		      6)
(define INV_TIARA		      7)
(define INV_NECKLACE		  8)
(define INV_EARRINGS		  9) 
(define INV_BROOCH		     10)
(define INV_MALLET		     11)
(define INV_GOLDKEY		     12)
(define INV_EMPTYBASKET		 13)
(define INV_BASKET		     14)
(define INV_BOTTLE		     15)
(define INV_EMPTYBOTTLE		 16)
(define INV_HAM	             17)
(define INV_SOUP	  	     18)
(define INV_CLOAK		     19)
(define INV_CROSS		     20)
(define INV_NIGHTINGALE		 21)
(define INV_EMPTYCAGE		 22)
(define INV_LAMP		     23)
(define INV_CLOTH		     24)
(define INV_PILLOW		     25)
(define INV_NET		         26)
(define INV_CARPET		     27)
(define INV_BRIDLE		     28)
(define INV_CANDLE		     29)
(define INV_SUGARCUBE		 30)
(define INV_GASPFISH		 31)
(define INV_AMULET		     32)
(define INV_CLAM		     33)
(define INV_SILVERKEY		 34)


// Fonts
(define DEFAULT_FONT          0)
(define WINDOW_FONT           1)
(define SMALL_FONT            4)
(define LARGE_FONT            9)
(define DEBUG_FONT          999)

// Menu IDs eg. $302 means third menu, second item
(define MENU_ABOUT			$101)
(define MENU_HELP			$102)
(define MENU_RESTART		$201)
(define MENU_SAVE			$202)
(define MENU_RESTORE		$203)
(define MENU_QUIT			$205)
(define MENU_PAUSE			$301)
(define MENU_INVENTORY		$302)
(define MENU_RETYPE			$303)
(define MENU_COLOURS		$305)
(define MENU_CHANGESPEED	$401)
(define MENU_FASTERSPEED	$403)
(define MENU_NORMALSPEED	$404)
(define MENU_SLOWERSPEED	$405)
(define MENU_VOLUME			$501)
(define MENU_TOGGLESOUND	$502)
