/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************
 rm001.sc
 Contains the first room of your game.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 1)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
(use "menubar")
/******************************************************************************/
(instance public rm001 of Rm
	(properties
		picture scriptNumber
		// Set up the rooms to go to/come from here
		north 43
		east 2
		south 8
		west 122
	)
	(method (init)
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))

  		// Check which room ego came from and position it
  		(switch(gPreviousRoomNumber)
            /******************************************************
             * Put the cases here for the rooms ego can come from *
             ******************************************************/
             
            (case north
               (send gEgo:
               		posn(220 38)
               		loop(2)
			   )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (if (>= (send gEgo:y) 127)
                	(send gEgo:
                		posn(10 125)
                		loop(0)
					)
				)(else
					(if (<= (send gEgo:y) 70)
						(send gEgo:
							posn(10 65)
							loop(0)
						)
					)(else
                		(send gEgo:
                    		posn(10 (send gEgo:y) ) //y is remembered
                    		loop(0)
						)
					 )
				 )
			)
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
            			
            // Set up ego's position if it hasn't come from any room
  			(default
                (Animate((DrawPic(1 dpCLOSEREOPEN_CHECKBOARD))))
                (send gEgo:
  					posn(139 132)
  					loop(0)
  				)
			)
  		)

		// Set up the ego
		SetUpEgo()
		(if (== (gPreviousRoomNumber) 122)
			(send gEgo:init()setCycle(StopSwim 5 5))
		)(else
			(send gEgo:init())
		 )
		(self:setRegions(700))

        /****************************************
         * Set up the room's music to play here *
         ****************************************/ /*
		(send gTheMusic:
			prevSignal(0)
			stop()
			number(scriptNumber)
			loop(-1)
			play()
		)*/

        /**************************************************
         * Add the rest of your initialization stuff here *
         **************************************************/
	)
	
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	 
	
	(method (doit)
		(super:doit())
					
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(43))
		)
	)
	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))
		
        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        
     )
)
/******************************************************************************/
