/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 2)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")

(local
	thisWindow
)
/******************************************************************************/
(instance public rm002 of Rm
	(properties
		picture scriptNumber
		north 44
		east 3
		south 9
		west 1
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

		(switch(gPreviousRoomNumber)
            (case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
               (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
    	(default
				(send gEgo:
					posn(150 100)
					loop(0)
				)
			)
		)

		SetUpEgo()
		(send gEgo:init())
		(self:setLocales(702))
		//LITTLE RED RIDING HOOD GOES HERE
		(if (not (send gEgo:has(INV_BOUQUET)))
			(if (== gMermaidFlowers 0)
				(RidingHood:init())
			)
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
    (method (changeState newState)
 		 = state newState
  		(switch(state)
    		(case 0
			)
		)
	 )
    
    (method (doit)
		(super:doit())
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(44))
		)
	)
    (method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        (if(Said('look>'))
        	(if(Said('/fence'))
            	Print(2 0)
			)
        	(if(Said('/rock'))
            	Print(2 2)
			)
        )
        (if(Said('take>'))
        	(if(Said('/sand'))
            	Print(700 9)
			)
        	(if(Said('/rock'))
            	Print(2 3)
        	)
        	(if(Said('/flower'))
            	Print(700 10)
			)
		)
        (if(Said('*/fence'))
            Print(2 1)
        )
        (if(Said('give>'))
        	(if(Said('/basket/girl'))
        		(if (send gEgo:has(INV_BASKET))
        			(if (<= (send gEgo:distanceTo(RidingHood)) 30)
        				Print("Gratefully, Little Red Riding Hood accepts the basket of goodies. In return, she gives you her bouquet of flowers.")
						(send gEgo:put(INV_BASKET)get(INV_BOUQUET))
						= gRidingHoodGoodies 1
        				(send gGame:changeScore(4))
        				(RidingHood:setLoop(1))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					Print("You don't have that.")
				 )
			)
		)
 	)
)
/******************************************************************************/
(instance RidingHood of Prop
	(properties
		x 237
		y 140
		view 49
	)
)