/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 3)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")
(use "window")
/******************************************************************************/
(instance public rm003 of Rm
	(properties
		picture scriptNumber
		north 45
		east 4
		south 10
		west 2
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

		(switch(gPreviousRoomNumber)
            (case north
               (if (>= (send gEgo:x()) 35 and <= (send gEgo:x()) 160)
               		(send gEgo:posn(35 40)loop(2))
			   )(else
			   		(if (> (send gEgo:x()) 160 and <= (send gEgo:x()) 300)
			   			(send gEgo:posn(300 40)loop(2))
					)(else
						(send gEgo:
    	               		posn((send gEgo:x) 40) //x is remembered
                   			loop(2)
               			)
				 	)
				)
            )
            (case east
               (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (if (< (send gEgo:y) 95)
                	(send gEgo:
                		posn(15 50)
                		loop(0)
					)
				)(else
					(send gEgo:
                    	posn(10 send gEgo:y) //y is remembered
                    	loop(0)
					)
				 )
			)
            (case south
                (if (< (send gEgo:x) 160)
                	(send gEgo:
                		posn(65 180)
                		loop(3)
					)
				)(else
					(if (>= (send gEgo:x) 160)
						(send gEgo:
							posn(237 180)
							loop(3)
						)
					)
				 )
			)
            (case 70
				(send gEgo:
				posn(138 100)
				loop(2)
				)
			)
            (default
				(send gEgo:
					posn(103 125)
					loop(0)
				)
			)
		)

		SetUpEgo()
		(send gEgo:init())
        (if (gMailBoxClosed)
        	(theMailbox:
            	init()
            	ignoreActors()
	        )
		)(else
			(theMailbox:
            	cel(4)
            	init()
            	ignoreActors()
	        )
		 )
		(if (== (gPreviousRoomNumber) 70)
			(theDoor:init()close())
		)(else
        	(theDoor:init())
		 )
		(self:setLocales(702))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
    (method (doit)
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(45))
		)
	)
    (method (handleEvent pEvent)
        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
     /*   (if(Said('look / '))
            Print("")
        )*/
        (if(Said('look>'))
	        (if(Said('/fence'))
    	        Print(3 0)
        	)
        	(if(Said('/tree'))
	            Print(3 1)
        	)
        	(if(Said('/flower , windowbox , box'))
	            Print(3 2)
        	)
        	(if(Said('/cottage'))
	            Print(3 3)
        	)
        	(if(Said('/window'))
        		Print(3 4)
			)
        	(if(Said('<in / mailbox'))
        			(if (== (send gEgo: onControl()) ctlSILVER)
        				(if (gMailBoxClosed)
        					Print(3 5)
						)(else
							(if (send gEgo:has(INV_BASKET))
								Print(3 6)
							)(else
								(if (send gEgo:has(INV_EMPTYBASKET))
									Print(3 6)
								)(else
									Print(3 7)
								 )
							 )
						 )
					)(else
						PrintNotCloseEnough()
					 )
			)
			(if(Said('/mailbox'))
	            Print(3 8)
        	)
        	(if(Said('/door'))
        		(if (== theDoor:cel() 0)
        			Print(3 9)
				)(else
					Print(3 10)
				 )
			)
        	(if(Said('[/!*]'))
	            Print(3 3)
        	)
		)
		(if(Said('open/door'))
			(if(<> (send gEgo:loop()) 3)
				(send gEgo:loop(3))
				(theDoor:open())
			)(else
				(theDoor:open())
			 )
		)
		(if(Said('close/door'))
			(if(<> (send gEgo:loop()) 3)
				(send gEgo:loop(3))
				(theDoor:close())
			)(else
				(theDoor:close())
			 )
		)
		(if(Said('knock [/door]'))
			(if(<= (send gEgo:distanceTo(theDoor)) 17)
				(if (> (theDoor:cel()) 0)
					Print("The door is open.")
				)(else
					(egoKnock:init()hide()setScript(knockScript))
					(knockScript:changeState(0))
			 	)
			)(else
				Print("Stand directly in front of the door first.")
			 )
		)
       	(if(Said('open / mailbox'))
        	(if (== (send gEgo: onControl()) ctlSILVER)
 	   			(if (gMailBoxClosed)
 	   				(if (send gEgo:has(INV_BASKET))
 	   					= gMailBoxClosed FALSE
       					(theMailbox:setCycle(End)setScript(mailboxOpenBasket))
       					(mailboxOpenBasket:changeState(3))
					)(else
						(if (send gEgo:has(INV_EMPTYBASKET))
 	   						= gMailBoxClosed FALSE
       						(theMailbox:setCycle(End)setScript(mailboxOpenBasket))
       						(mailboxOpenBasket:changeState(3))
						)(else
							(theMailbox:setScript(mailboxOpenBasket))
							(mailboxOpenBasket:changeState(0))
						 )
					 )
				)(else
					PrintItIs()
			 	)
			)(else
				PrintNotCloseEnough()
		 	)
		)	 
        (if(Said('close / mailbox'))
        	(if (== (send gEgo: onControl()) ctlSILVER)
        		(if (gMailBoxClosed)
        			PrintItIs()
				)(else
					= gMailBoxClosed TRUE
        			(theMailbox:setCycle(Beg))					 
				 )
			
			)(else
				PrintNotCloseEnough()
			 )
		)
        (if(Said('take>'))
        	(if(Said('/basket,goodies,basket<goodies'))
        		(if (send gEgo:has(INV_BASKET))
	        		PrintAlreadyTookIt()
				)(else
					(if (send gEgo:has(INV_EMPTYBASKET))
						PrintAlreadyTookIt()
					)(else
        				(if (== (send gEgo: onControl()) ctlSILVER)
	        				(if (gMailBoxClosed)
        						Print(3 11)
							)(else
								PrintOK()
								(send gGame:changeScore(3))
								(send gEgo:get(INV_BASKET))
							 )
						)(else
							Print("Where do you think it could be?")
						 )
					 )
				 )
			)
			(if(Said('/mailbox'))
				Print(3 12)
			)
			(if(Said('/fence'))
				Print(3 13)
				Print(3 14)
			)
			(if(Said('/flower'))
				Print(3 15)
			)
		)
		(if(Said('*/fence'))
            Print(2 1)
        )
/*		(if(Said('break/*'))
			Print("There's no need to do that. The door is unlocked.")
		)*/
	)
)
/******************************************************************************/
(instance mailboxOpenBasket of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(state)
			(case 0
				ProgramControl()
				= gProgramControl TRUE
				= gMailBoxClosed FALSE
   				(theMailbox:setCycle(End mailboxOpenBasket))
			)
			(case 1
				Print(3 16)
				PlayerControl()
				= gProgramControl FALSE
			)
			(case 3
				ProgramControl()
				= gProgramControl TRUE
				= gMailBoxClosed FALSE
				(theMailbox:setCycle(End mailboxOpenBasket))
			)
			(case 4
				Print(3 17)
				PlayerControl()
				= gProgramControl FALSE
			)
		)
	)
)
(instance knockScript of Script
	(properties)
	(method (changeState newState)
		(var yStart, xStart, yFinish, xFinish, w, h, w2, h2, x, y)
		= state newState
		(switch(state)
			(case 0 = cycles 1
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide())
				(egoKnock:show()loop(0)posn((send gEgo:x) (send gEgo:y)))
			)
			(case 1 = cycles 8
				(egoKnock:loop(1)setCycle(Fwd))
			)
			(case 2 = cycles 2
				(egoKnock:setCycle(End))
			)
			(case 3 = cycles 1
				(egoKnock:hide())
				(send gEgo:show()loop(3))
				Print(3 18
					#dispose 
					#mode alCENTER
					#width 95
					#time 3
					#title "Muffled Voice"
					#at 152 23
					#time 3
					)
			)
			(case 4
				PlayerControl()
				= gProgramControl FALSE
			)
		)
	)
)
(instance theMailbox of Prop
  (properties
    x 58
    y 159
	z 24
    view 020
  )
)
(instance theDoor of Door
	(properties
		x 123
		y 95
		view 021
		entranceTo 70
		cycleSpeed 1
	)
)
(instance egoKnock of Prop
	(properties
		x 0
		y 0
		view 8
	)
)