/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 13)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm013 of Rm
	(properties
		picture scriptNumber
		north 6
		east 14
		south 20
		west 12
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
				(if (<= (send gEgo:x) 160)
               		(send gEgo:
                   		posn(40 50) //x is remembered
                   		loop(2)
               		)
				)(else
					(send gEgo:
						posn(305 50)
						loop(2)
					)
				 )
            )
            (case east
                (if (<= (send gEgo:y) 33)
                	(send gEgo:
                		posn(310 50)
                		loop(1)
					)
				)(else							
                	(send gEgo:
                   	posn(310 send gEgo:y)  //y is remembered
                   	loop(1)
					)
				 )
            )
            (case west
            	(if (<= (send gEgo:y) 33)
            		(send gEgo:
            			posn(10 50)
            			loop(0)
					)
				)(else
					(if (>= (send gEgo:y) 180)
						(send gEgo:
							posn(10 179)
							loop(0)
						)
					)(else
	                	(send gEgo:
    	                	posn(10 send gEgo:y) //y is remembered
        	            	loop(0)
            	    	)
					 )
				 )
			)
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if (not (send gEgo:has(INV_BROOCH)))
			(Brooch:init())
		)
		(self:setLocales(702))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if (== (send gEgo:onControl()) ctlGREEN)
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoWading gEgoWading))
		)
		(if (== (send gEgo:onControl()) (| ctlTEAL ctlGREEN))
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (& (send gEgo:onControl()) ctlTEAL)
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (== (send gEgo:onControl()) (| ctlTEAL ctlMAROON))
			(send gEgo:setCycle(StopWalk gEgoWadingDeep gEgoWadingDeep))
		)
		(if (& (send gEgo:onControl()) ctlMAROON)
			(send gEgo:setCycle(StopSwim gEgoSwimming gEgoSwimming))
		)
		(if (& (send gEgo:onControl()) ctlNAVY)
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) (| ctlNAVY ctlBLACK))
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) (| ctlNAVY ctlGREEN))
			(if (== (send gEgo:view()) (gEgoView))
				(ankleWater:init()setCycle(Fwd))
			)(else
				(if (== (send gEgo:view()) (gEgoStoppedView))
					(ankleWater:init()setCycle(CT))
				)(else
					(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
				 )
			 )
		)
		(if (== (send gEgo:onControl()) ctlBLACK)
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
		)
		(if (== (send gEgo:onControl()) (| ctlSILVER ctlNAVY))
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
		)
		(if (& (send gEgo:onControl()) ctlSILVER)
			(ankleWater:dispose())
			(send gEgo:setCycle(StopWalk gEgoView gEgoStoppedView))
		)
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(6))
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('look>'))
        	(if(Said('/rock'))
            	Print(13 1)
        	)
        	(if(Said('/tree'))
	            Print(2 0)
        	)
        	(if(Said('/grass , ground'))
        		Print(2 3)
			)
			(if(Said('/plant'))
	            Print(13 2)
        	)
        	(if(Said('/flower'))
	            Print(13 3)
        	)
        	(if(Said('/stump'))
        		Print(13 4)
			)
			(if(Said('/hole'))
				(if (== (send gEgo:onControl()) ctlSILVER)
					(if (not (send gEgo:has(INV_BROOCH)))
						Print(13 5)
					)(else
						Print(13 7)
					 )
				)(else
					Print(13 6)
				 )
			)
        	(if(Said('[/pond,water]'))
	            Print(13 0)
        	)
        	(if(Said('/*'))
	            Print(0 9)
			)
		)
		(if(Said('take>'))
			(if(Said('/brooch'))
				(if (== (send gEgo:onControl()) ctlSILVER)
					(if (not (send gEgo:has(INV_BROOCH)))
						(Brooch:setScript(broochScript))
					)(else
						Print("It's not there.")
				 	)
				)(else
					(if (send gEgo:has(INV_BROOCH))
						Print("It's not there.")
					)(else
						PrintNotCloseEnough()
					 )
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance ankleWater of Prop
    (properties
        x 0
        y 0
        view 2
        cel 0
	)
    (method (init)
        (super:init())
        (self:z(89))
        (self:setScript(anklewaterScript))
    )
)
 
(instance anklewaterScript of Script
    (properties)
    (method (doit)
        (ankleWater:
            posn((send gEgo:x) (- (send gEgo:y) -90))
            setPri(send gEgo:priority)
		)
        (super:doit())
	)
)
(instance egoPickup of Prop
	(properties
		view 13
	)
)
(instance broochScript of Script
	(properties)
	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0 = cycles 1
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide()loop(0))
				(egoPickup:
					posn((send gEgo:x) (send gEgo:y))
					loop(0)
					init()
				)
			)
			(case 1
				(egoPickup:setCycle(End broochScript))
			)
			(case 2
				(Brooch:dispose())
				(send gGame:changeScore(8))
				(send gEgo:get(INV_BROOCH))
				(egoPickup:setCycle(Beg broochScript))
			)
			(case 3
				(egoPickup:dispose())
				(send gEgo:show())
				PlayerControl()
				= gProgramControl FALSE
			)
		)
	)
)
(instance Brooch of Prop
	(properties
		x 105
		y 78
		view 28
		cel 0
	)
)