/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 15)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(local
	HorseAppear = 0
)
/******************************************************************************/
(instance public rm015 of Rm
	(properties
		picture scriptNumber
		north 8
		east 16
		south 22
		west 128
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn(280 180) //x is remembered
                    loop(3)
                )
            )
            (case 54
            	(send gEgo:
            		posn(50 112)
            		loop(0)
				)
				(MenuBar:draw())
				(SL:enable())
				PlayerControl()
				= gProgramControl FALSE
				(Seahorse:init()setLoop(1))
				(RoomScript:changeState(1))
			)
		)
		
		SetUpEgo()
		(if (== (gPreviousRoomNumber) 128)
			(send gEgo:init()setCycle(StopSwim gEgoSwimming gEgoSwimming))
		)(else
			(if (== (gPreviousRoomNumber) 54)
				(send gEgo:init()setCycle(StopSwim gEgoSwimming gEgoSwimming))
			)(else
				(send gEgo:init())
		 	)
		 )
		(self:setRegions(700))
		(if (== gKeyQuest 1)
			(Mermaid:init()setCycle(Fwd)setPri(5))
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gRoom:newRoom(8))
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('give>'))
			(if (Said('/flowers/mermaid'))
				(if (send gEgo:has(INV_BOUQUET))
					(if (<= (send gEgo:distanceTo(Mermaid)) 40)
						Print("You graciously offer the beautiful bouquet of wildflowers to the mermaid. She loves the flowers! She then summons forth a magic seahorse! Maybe you could ride it.")
						(send gEgo:put(INV_BOUQUET))
						= gMermaidFlowers 1
						(send gGame:changeScore(2))
						(Seahorse:init()setCycle(Beg))
						= HorseAppear 1
						(Mermaid:setScript(MermaidDive))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					Print("You don't have that.")
				 )
			)
			(if (Said('/flowers'))
				(if (send gEgo:has(INV_BOUQUET))
					Print("Who do you want to give the flowers to?")
				)(else
					PrintDontHaveIt()
				 )
			)
		)
		(if (Said('ride>'))
			(if (Said('/seahorse'))
				(if (== HorseAppear 1)
					(if (<= (send gEgo:distanceTo(Seahorse)) 25)
						Print("Quick as a flash, it glides under the water with you on its back!")
						(send gGame:changeScore(2))
						(Seahorse:setScript(RideDive))
					)
				)
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
			(case 1 = cycles 1
				
			)
			(case 2
				(send gGame:setCursor(999 1))
				(Seahorse:setCycle(End RoomScript)setMotion(MoveTo 19 123)setStep(1 1))
			)
			(case 3
				(Seahorse:dispose())
			)
		)
	)
)
/******************************************************************************/
(instance MermaidDive of Script
	(properties)
	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				(Mermaid:setLoop(1)setCycle(End MermaidDive))
			)
			(case 1
				(Mermaid:dispose())
			)
		)
	)
)
(instance RideDive of Script
	(properties)
	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0 = cycles 1
				
			)
			(case 1
				ProgramControl()
				= gProgramControl TRUE
				(send gGame:setCursor(997 1))
				(send gEgo:hide())
				(Seahorse:setLoop(2)setCel(0)setCycle(End RideDive))
			)
			(case 2
				(send gRoom:newRoom(54))
			)
		)
	)
)
(instance Mermaid of Prop
	(properties
		x 49
		y 69
		view 48
		cycleSpeed 2
		priority 5
	)
)
(instance Seahorse of Act
	(properties
		x 32
		y 119
		view 50
		loop 0
		cel 5
	)
)