/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 18)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Wander")
(local
    GhostTouch = FALSE
)
/******************************************************************************/
(instance public rm018 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 25
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case 61
               (send gEgo:
                   posn(152 165) //x is remembered
                   loop(2)
               )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if(== gGhostsKill TRUE)
			(Ghost1:
                init()
                setCycle(Fwd)
                setMotion(Wander)
                observeControl(ctlSILVER)
                ignoreActors()
            )
            (Ghost2:
                init()
                setCycle(Fwd)
                setMotion(Wander)
                observeControl(ctlGREY)
                ignoreActors()
            )
			Print(18 0)
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
// DoIt Method - Repeatedly executed code
	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(== gGhostsKill FALSE)
			(if(== (send gEgo:onControl()) ctlNAVY)
				(send gRoom:newRoom(61))	
			)
		)(else
        	(if(< (send gEgo:distanceTo(Ghost1)) 10)
	            (if (== GhostTouch FALSE)
                	(if(== gWearingCloakRing 3)
	                	Print(18 1)
                		ghostsFade()
					)(else
						(if(== gWearingCross TRUE)
							Print(18 2)
							ghostsFade()
						)(else
							(Ghost1:setScript(GhostDeathScript))
					 	)
				 	)
            	)
        	)
        	(if(< (send gEgo:distanceTo(Ghost2)) 10)
	            (if (== GhostTouch FALSE)
                	(if(== gWearingCloakRing 3)
	                	Print(18 1)
                		ghostsFade()
					)(else
						(if(== gWearingCross TRUE)
							Print(18 2)
							ghostsFade()
						)(else
							(Ghost2:setScript(GhostDeathScript))
					 	)
				 	)
            	)
			)
        )
	)
// HandleEvent Method - Handles input
	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('look>'))
			(if(Said('/ghost'))
				(if(== gGhostsKill TRUE)
					Print(18 3)
				)(else
					Print(18 4)
				 )
			)
			(if(Said('/castle'))
				Print(18 5)
			)
			(if(Said('/door'))
				Print(18 6)
			)
			(if(Said('/island'))
				Print(18 7)
			)
		)
		(if(Said('rub/lamp'))
			(if (send gEgo:has(INV_LAMP))
				Print(18 8)
			)
		)
		(if(Said('ride/carpet'))
			(if (send gEgo:has(INV_CARPET))
				Print(18 9)
			)(else
				PrintDontHaveIt()
			 )
		)
		(if(Said('open/door'))
			(if(== gGhostsKill TRUE)
				Print(18 10)
			)(else
				(if(not send gEgo:inRect(133 159 171 165))
					Print(18 11)
				)(else
					(send gRoom:newRoom(61))	
				 )
			 )
		)
		(if(Said('knock/door'))
			(if(== gGhostsKill FALSE)
				(if(send gEgo:inRect(133 159 171 165))
					Print(18 17)
				)(else
					Print(18 11)
				 )
			)(else
				Print(18 10)
			 )
		)
		(if(Said('kill/ghost'))
			(if(== gGhostsKill TRUE)
				Print(18 12)
			)(else
				Print(18 4)
			 )
		)
		(if(Said('capture/ghost'))
			(if(== gGhostsKill TRUE)
				Print(18 13)
			)(else
				Print(18 4)
			 )
		)
		(if(Said('talk/ghost'))
			(if(== gGhostsKill TRUE)
				Print(18 14)
			)(else
				Print(18 4)
			 )
		)
		(if(Said('hello'))
			(if(== gGhostsKill TRUE)
				Print(18 14)
			)(else
				Print(18 4)
			 )
		)
		(if(Said('say/hello'))
			(if(== gGhostsKill TRUE)
				Print(18 14)
			)(else
				Print(18 4)
			 )
		)
	)
// ChangeState Method - Handles one-time events and/or cued events
	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Ghost1 of Act
	(properties
		x 150
		y 160
		view 64
	)
)
(instance Ghost2 of Act
	(properties
		x 180
		y 115
		view 64
	)
)
(instance tranceGraham of Act
    (properties
        view 18
    )
)
(procedure (ghostsFade)
	= gGhostsKill FALSE
	= GhostTouch TRUE
	(Ghost1:setScript(GhostFadeScript))
)
(instance GhostFadeScript of Script
	(properties)
	(method (changeState GhostFadeState)
		(= state GhostFadeState)
		(switch (GhostFadeState)
			(case 0
				(Ghost1:
                    cycleSpeed(1)
                    view(65)
                    setMotion(MoveTo (- Ghost1:x 50) (+ Ghost1:y 3))
                    cel(0)
                    setCycle(End)
                    ignoreControl(ctlSILVER)
                )
				(Ghost2:
                    cycleSpeed(1)
                    view(65)
                    setMotion(MoveTo (+ Ghost2:x 50) (+ Ghost2:y 3))
                    cel(0)
                    setCycle(End GhostFadeScript)
                    ignoreControl(ctlGREY)
                )
			)
			(case 1
				(Ghost1:dispose())
				(Ghost2:dispose())
			)
		)
	)
)
(instance GhostDeathScript of Script
    (properties)
    (method (changeState GhostDeathState)
    (var dyingScript)
        (= state GhostDeathState)
        (switch (GhostDeathState)
            (case 0
                = GhostTouch TRUE
                ProgramControl()
				= gProgramControl TRUE
                Print(18 15)
                (GhostDeathScript:cue())
            )
            (case 1
                (Ghost1:
                    cycleSpeed(1)
                    view(65)
                    setMotion(MoveTo (- Ghost1:x 50) (+ Ghost1:y 3))
                    setCel(0)
                    setCycle(End)
                )
                (Ghost2:
                    cycleSpeed(1)
                    view(65)
                    setMotion(MoveTo (+ Ghost2:x 50) (+ Ghost2:y 3))
                    setCel(0)
                    setCycle(End GhostDeathScript)
                )
            )
            (case 2
                (Ghost1:dispose())
                (Ghost2:dispose())
                (if (== gSugarCube 1)
                    Print(18 16)
                )
                (send gEgo:hide())
                (tranceGraham:
                    init()
                    posn((send gEgo:x) (send gEgo:y))
                    setCycle(Walk)
                    setMotion(MoveTo 65 (send gEgo:y) GhostDeathScript)
                )
            )
            (case 3
                (tranceGraham:
                    view(16)
                    setLoop(1)
                )
                = dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("You have been poisoned by the thorns and can no longer continue the game.")
				)
  				(send gGame:setScript(dyingScript))
            )
        )
    )
)
