/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 20)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm020 of Rm
	(properties
		picture scriptNumber
		north 13
		east 21
		south 27
		west 19
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		SetUpEgo()
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
                   init()
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
                   init()
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                    init()
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                    init()
                )
            )
            (case 68
            	(send gEgo:
            		posn(185 134)
            		loop(1)
            		init()
				)
			)
			(case 105
				(send gEgo:
					init()
					posn(118 73)
					loop(1)
					hide()
				)
				(RoomScript:changeState(1))
			)
		)
		
		
		(self:setLocales(702))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if (send gEgo:inRect(183 115 209 130))
			(if ((== gKeyQuest 3) and (== gAntiqueBird FALSE))
				(send gRoom:newRoom(68))
			)(else
				Print("The antique store is closed. You cannot enter it.")
			 )
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
			(case 1
				(EgoCarpet:
					init()
					setStep(4 4)
					setPri(send gEgo:priority())
					setCycle(Fwd)
					setMotion(MoveTo 118 73 RoomScript)
					ignoreControl(ctlWHITE)
				)
			)
			(case 2
				= gProgramControl FALSE				
				PlayerControl()
				= gCarpetFlying FALSE
				(EgoCarpet:dispose())
				(if(== gKeyQuest 4)
					= gCanFlyCarpet FALSE
				)
				(send gEgo:show())				
			)
		)
	)
)
/******************************************************************************/
(instance EgoCarpet of Act
	(properties
		x 118
		y 0
		view 15
		loop 1
	)
)