/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 22)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm022 of Rm
	(properties
		picture scriptNumber
		north 15
		east 23
		south 29
		west 131
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(self:setRegions(700))
		(if (not (send gEgo:has(INV_BRACELET)))
			(if (not (send gEgo:has(INV_CLAM)))
				(Clam:init())
			)(else
				(Bracelet:init())
			 )
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('take>'))
			(if (Said('/clam'))
				(if (not (send gEgo:has(INV_CLAM)))
					(if (<= (send gEgo:distanceTo(Clam)) 10)
						Print("When you pick up the clamshell, you see that there was a sparkling sapphire and diamond bracelet under it!")
						(Clam:dispose())
						(send gEgo:get(INV_CLAM))
						(Bracelet:init()ignoreActors()setPri(0))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintAlreadyTookIt()
				 )
			)
			(if (Said('/bracelet'))
				(if (not (send gEgo:has(INV_BRACELET)))
					(if (send gEgo:has(INV_CLAM))
						(if (<= (send gEgo:distanceTo(Bracelet)) 10)
							PrintOK()
							(Bracelet:dispose())
							(send gGame:changeScore(7))
							(send gEgo:get(INV_BRACELET))
						)(else
							PrintNotCloseEnough()
					 	)
					)(else
						Print("You don't see that here.")
					 )
				)(else
					PrintAlreadyTookIt()
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Clam of Prop
	(properties
		x 206		
		y 111
		view 41
	)
)
(instance Bracelet of Prop
	(properties
		x 206
		y 111
		view 42
	)
)