/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 32)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(local
	GhoulPayment = 0		// 0=not paid,1=paid treasure,2=cloak & ring,3=cloak & ring & paid trasure
)
/******************************************************************************/
(instance public rm032 of Rm
	(properties
		picture scriptNumber
		north 0
		east 33
		south 39
		west 31
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		SetUpEgo()
		(send gEgo:init())
		(switch(gPreviousRoomNumber)
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
            (case 25
            	(send gEgo:
            		posn(187 152)
            		loop(2)
            		hide()
				)
				(RoomScript:changeState(2))
			)
		)
				
		(self:setLocales(702))
		
		(if(== gKeyQuest 5 and <> gPreviousRoomNumber 25)
			(Ferryman:init())
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(== (RoomScript:state()) 3)
			(RoomScript:changeState(0))
		)

	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...

		(if(Said('get<in/boat'))
			(if(== gKeyQuest 5)
				(if(<= (send gEgo:distanceTo(Ferryman)) 30)
					(if(== gWearingCloakRing 3 and == GhoulPayment 0)
						= GhoulPayment 2
					)
					(switch(GhoulPayment)
						(case 0
							Print("The spooky fiend holds out a bony claw, as if in request for a payment of some kind.")
						)
						(case 1
							Print("You climb carefully into the old boat. The shrouded ghoul paddles it across the lake to the ominous island.")
							= gProgramControl TRUE
							ProgramControl()
							FerryToCastle()
						)
						(case 2
							Print("The shrouded ghoul looks at the ruby ring on your finger and the black cloak around your neck. He motions for you to enter the boat, which you do. You must have fooled him into thinking you were someone else.")
							= gProgramControl TRUE
							ProgramControl()
							FerryToCastle()
						)
						(case 3
							Print("You climb carefully into the old boat. The shrouded ghoul paddles it across the lake to the ominous island.")
							= gProgramControl TRUE
							ProgramControl()
							FerryToCastle()
						)
					)
				)(else
					PrintNotCloseEnough()
				 )
			)(else
				Print("There's no boat here.")
			 )
		)
		(if(Said('give/ghoul/necklace'))
			(if(send gEgo:has(INV_NECKLACE))
				(if(<= send gEgo:distanceTo(Ferryman) 30)
					(send gEgo:put(INV_NECKLACE))
					FerrymanAccept()
				)(else
					PrintNotCloseEnough()
				 )
			)(else
				PrintDontHaveIt()
			 )
		)
		(if(Said('give/ghoul/brooch'))
			(if(send gEgo:has(INV_BROOCH))
				(if(<= send gEgo:distanceTo(Ferryman) 30)
					(send gEgo:put(INV_BROOCH))
					FerrymanAccept()
				)(else
					PrintNotCloseEnough()
				 )
			)(else
				PrintDontHaveIt()
			 )
		)
		(if(Said('give/ghoul/earrings'))
			(if(send gEgo:has(INV_EARRINGS))
				(if(<= send gEgo:distanceTo(Ferryman) 30)
					(send gEgo:put(INV_EARRINGS))
					FerrymanAccept()
				)(else
					PrintNotCloseEnough()
				 )
			)(else
				PrintDontHaveIt()
			 )
		)
		(if(Said('give/ghoul/bracelet'))
			(if(send gEgo:has(INV_BRACELET))
				(if(<= send gEgo:distanceTo(Ferryman) 30)
					(send gEgo:put(INV_BRACELET))
					FerrymanAccept()
				)(else
					PrintNotCloseEnough()
				 )
			)(else
				PrintDontHaveIt()
			 )
		)
		(if(Said('give/ghoul/tiara'))
			(if(send gEgo:has(INV_TIARA))
				(if(<= send gEgo:distanceTo(Ferryman) 30)
					(send gEgo:put(INV_TIARA))
					FerrymanAccept()
				)(else
					PrintNotCloseEnough()
				 )
			)(else
				PrintDontHaveIt()
			 )
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
			(case 1
				(send gRoom:newRoom(25))
			)
			(case 2
				FerryFromCastle()
			)
			(case 3
				PlayerControl()
				= gProgramControl FALSE
				(send gEgo:show())
				(Ferryman:
					view(57)
					loop(0)
					setCycle(NULL)
					cel(0)
				)
			)
		)
	)
)
/******************************************************************************/
(instance Ferryman of Act
	(properties
		x 188
		y 141
		view 57
	)
)
(procedure (FerrymanAccept)
	Print("The shrouded ghoul takes your treasure. Silently, he gestures toward the boat.")
	(Ferryman:setCycle(End))
	(switch(GhoulPayment)
		(case 0			
			= GhoulPayment 1
		)
		(case 2
			= GhoulPayment 3
		)
	)
)
(procedure (FerryToCastle)
	(send gEgo:hide())
	(Ferryman:
		view(58)
		loop(1)
		setCycle(Fwd)
		setMotion(MoveTo 151 71 RoomScript)
	)
)
(procedure (FerryFromCastle)
	(Ferryman:
		view(58)
		init()
		posn(151 71)
		setCycle(Fwd)
		setMotion(MoveTo 188 141 RoomScript)
	)
)
		