/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 42)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm042 of Rm
	(properties
		picture scriptNumber
		north 35
		east 0
		south 49
		west 41
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(self:setLocales(702))
		
		(switch(gKeyQuest)
			(case 0										// No key Quest
				(MagicDoor:init())
			)
			(case 1										// Get first key Quest
				(MagicDoor:init())
			)
			(case 2										// Have first key
				(if (not (send gEgo:has(INV_GOLDKEY)))
					(MagicDoor:init()setLoop(1))
				)(else
					(MagicDoor:init())
				 )
			)
			(case 3										// Get second key Quest
				(MagicDoor:init()setLoop(1))
			)
			(case 4										// Have second key
				(if (not (send gEgo:has(INV_GOLDKEY)))
					(MagicDoor:init()setLoop(2))
				)(else
					(MagicDoor:init()setLoop(1))
				 )
			)
			(case 5										// Get third key Quest
				(MagicDoor:init()setLoop(2))
			)
			(case 6										// Have third key
				(if (not (send gEgo:has(INV_GOLDKEY)))
					(MagicDoor:init()setLoop(2)setCel(2))
				)(else
					(MagicDoor:init()setLoop(2))
				 )
			)
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('unlock>'))
			(if (Said('/door'))
				(if (send gEgo:has(INV_GOLDKEY))
					(if (<= (send gEgo:distanceTo(MagicDoor)) 20)
						(switch(gKeyQuest)
							(case 2										// Have first key
								Print("The key to the first door fits easily into the keyhole. You turn the key and, PRESTO, the door opens, and the key disappears . . . revealing a second door with another inscription!")
								(send gEgo:put(INV_GOLDKEY))
								(send gGame:changeScore(7))
								(MagicDoor:setCycle(End))
							)
							(case 4										// Have second key
								Print("The key to the first door fits easily into the keyhole. You turn the key and, PRESTO, the door opens, and the key disappears . . . revealing a second door with another inscription!")
								(send gEgo:put(INV_GOLDKEY))
								(send gGame:changeScore(7))
								(MagicDoor:setCycle(End))
							)
							(case 6										// Have third key
								Print("The key to the third door fits easily into the keyhole. You turn the key and, PRESTO, the door opens, and again the key disappears . . . revealing a world unlike any you've ever seen before!")
								(send gEgo:put(INV_GOLDKEY))
								(send gGame:changeScore(7))
								(MagicDoor:setScript(ThirdDoorScript))
							)
						)
					)(else
						Print("You are too far away from the door.")
				 	)
				)(else
					Print("You can't. You don't have the key.")
				 )
			)
		)
		(if (Said('read>'))
			(if (Said('/inscription'))
				(if (<= (send gEgo:distanceTo(MagicDoor)) 20)
					(switch(gKeyQuest)
						(case 0										// No key Quest
							++gKeyQuest
							Print("The inscription reads: Whosoever chooses to seek the key for this door will undoubtedly make a splash.")
						)
						(case 1										// Get first key Quest
							Print("The inscription reads: Whosoever chooses to seek the key for this door will undoubtedly make a splash.")
						)
						(case 2										// Have first key
							(if (not (send gEgo:has(INV_GOLDKEY)))
							++gKeyQuest
							Print("The inscription reads: Whosoever chooses to seek the key for this door should set their sights high.")
							)(else	
								Print("The inscription reads: Whosoever chooses to seek the key for this door will undoubtedly make a splash.")
			 				)
						)
						(case 3										// Get second key Quest
							Print("The inscription reads: Whosoever chooses to seek the key for this door should set their sights high.")
						)
						(case 4										// Have second key
							(if (not (send gEgo:has(INV_GOLDKEY)))
								++gKeyQuest
								Print("Whosoever chooses to seek the last key must have a stout heart.")
							)(else
								Print("The inscription reads: Whosoever chooses to seek the key for this door should set their sights high.")
				 			)
						)
						(case 5										// Get third key Quest
							Print("Whosoever chooses to seek the last key must have a stout heart.")
						)
						(case 6										// Have third key
							Print("Whosoever chooses to seek the last key must have a stout heart.")
						)
					)
				)(else
					Print("You are too far away from the door.")
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance ThirdDoorScript of Script
	(properties)
	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				(MagicDoor:setCycle(End ThirdDoorScript))
			)
			(case 1
				(send gRoom:newRoom(80))
			)
		)
	)
)
(instance MagicDoor of Prop
	(properties
		x 177
		y 102
		view 39
		loop 0
		cel 0
	)
)