/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 48)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(local
	onBridge = 0
	falling = FALSE
)
/******************************************************************************/
(instance public rm048 of Rm
	(properties
		picture scriptNumber
		north 41
		east 49
		south 6
		west 47
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
            	(if (<= (send gEgo:y) 59)
            		(send gEgo:
            			posn(10 60)
            			loop(0)
					)
				)(else
                	(send gEgo:
                    	posn(10 send gEgo:y) //y is remembered
                    	loop(0)
					)
				 )
            )
            (case south
                (if (>= (send gEgo:x) 182)
                	(send gEgo:
                		posn(182 183)
                		loop(3)
					)
				)(else
                	(send gEgo:
                    	posn((send gEgo:x) 180) //x is remembered
                    	loop(3)
                	)
				 )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(self:setLocales(702))
		(brokenBoards:init()ignoreActors()ignoreControl(ctlWHITE)setPri(3))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		
		(if ((== (send gEgo:onControl()) ctlGREEN) and not onBridge)
			= onBridge 1
			= gBridgeBreak (++gBridgeBreak)
			(if (< gBridgeBreak 8)
				(send gGame:changeScoreSilent(1))
			)
		)(else
			(if ((== (send gEgo:onControl()) ctlBLACK) and onBridge)
				= onBridge 0
			)
		 )
		(if (== gBridgeBreak 8)
			(brokenBoards:setScript(breakScript))			
		)
		(if(<> falling TRUE)
			(if (== (send gEgo:onControl()) ctlYELLOW)
				(egoFall:init()hide()x(send gEgo:x)y(send gEgo:y))
				(if(== (send gEgo:loop) 3)
					(egoFall:setLoop(9))
				)(else
					(if(== (send gEgo:loop) 0)
						(egoFall:setLoop(6))
					)(else
						(if(== (send gEgo:loop) 2)
							(egoFall:setLoop(3))
						)(else
							(if(== (send gEgo:loop) 1)
								(egoFall:setLoop(9))
							)
						 )
					 )
				 )
				= falling TRUE
			)
			(if (== (send gEgo:onControl()) ctlFUCHSIA)
				(egoFall:init()hide()x(send gEgo:x)y(send gEgo:y)setPri(11))
				(if(== (send gEgo:loop) 3)
					(egoFall:setLoop(9))
				)(else
					(if(== (send gEgo:loop) 0)
						(egoFall:setLoop(6))
					)(else
						(if(== (send gEgo:loop) 2)
							(egoFall:setLoop(3))
						)(else
							(if(== (send gEgo:loop) 1)
								(egoFall:setLoop(9))
							)
						 )
					 )
				 )
				= falling TRUE
			)
			(if (== (send gEgo:onControl()) ctlRED)
				(egoFall:init()hide()x(send gEgo:x)y(send gEgo:y)setPri(7))
				(if(== (send gEgo:loop) 3)
					(egoFall:setLoop(9))
				)(else
					(if(== (send gEgo:loop) 0)
						(egoFall:setLoop(6))
					)(else
						(if(== (send gEgo:loop) 2)
							(egoFall:setLoop(3))
						)(else
							(if(== (send gEgo:loop) 1)
								(egoFall:setLoop(9))
							)
						 )
					 )
				 )
				= falling TRUE
			)
			(if (== (send gEgo:onControl()) ctlCYAN)
				(egoFall:init()hide()x(send gEgo:x)y(send gEgo:y)setPri(1))
				(if(== (send gEgo:loop) 3)
					(egoFall:setLoop(9))
				)(else
					(if(== (send gEgo:loop) 0)
						(egoFall:setLoop(6))
					)(else
						(if(== (send gEgo:loop) 2)
							(egoFall:setLoop(3))
						)(else
							(if(== (send gEgo:loop) 1)
								(egoFall:setLoop(9))
							)
						 )
					 )
				 )
				= falling TRUE
			)
			(if (== (send gEgo:onControl()) ctlLIME)
				(egoFall:init()hide()x(send gEgo:x)y(send gEgo:y)setPri(0))
				(if(== (send gEgo:loop) 3)
					(egoFall:setLoop(9))
				)(else
					(if(== (send gEgo:loop) 0)
						(egoFall:setLoop(6))
					)(else
						(if(== (send gEgo:loop) 2)
							(egoFall:setLoop(3))
						)(else
							(if(== (send gEgo:loop) 1)
								(egoFall:setLoop(9))
							)
						 )
					 )
				 )
				= falling TRUE
			)
			(if (== (send gEgo:onControl()) ctlBLUE)
				(egoFall:init()hide()x(send gEgo:x)y(send gEgo:y)setPri(1))
				(if(== (send gEgo:loop) 1)
					(egoFall:setLoop(7))
				)(else
					(if(== (send gEgo:loop) 2)
						(egoFall:setLoop(2))
					)
				 )
				= falling TRUE
			)
		)(else
			(self:setScript(fallScript))
		 )
		(if (& (send gEgo:onControl()) ctlPURPLE)
			(send gGame:newRoom(41))
		)

	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance fallScript of Script
	(properties)
	(method (changeState cliffState)
	(var dyingScript)
		(= state cliffState)
		(switch (cliffState)
			(case 0 = cycles 1
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide())
				(egoFall:
					show()
					ignoreActors()
					ignoreControl(ctlWHITE)
				)
			)
			(case 1
				(egoFall:
					setCycle(End fallScript)
				)
			)
			(case 2
				(egoFall:hide()dispose())
				(send gGame:setSpeed(6))
				Wait(180)
				ShakeScreen(20 ssUPDOWN)
				(self:cue())
			)
			(case 3
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("Whoops! You have fallen into the chasm, ending your quest.")
				)
  				(send gGame:setScript(dyingScript))
			)
		)
	)
)
(instance breakScript of Script
	(properties)
	(method (changeState breakState)
	(var dyingScript)
		(= state breakState)
		(switch (breakState)
			(case 0
				(breakScript:cue())
			)
			(case 1
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide())
				(egoFalling:
					init()
					ignoreActors()
					ignoreControl(ctlWHITE)
					x(send gEgo:x)
					setPri(6)
				)			
				(brokenBoards:setCycle(End breakScript)setPri(5))
			)
			(case 2
				(send gGame:setSpeed(2))
				(brokenBoards:
					loop(1)
					setStep(0 5)
					setMotion(MoveTo 253 187 breakScript)
				)
				(egoFalling:
					setStep(0 10)
					setMotion(MoveTo (send gEgo:x) 187)
				)
			)
			(case 3
				Wait(180)
				(send gGame:setSpeed(6))
				ShakeScreen(20 ssUPDOWN)
				(breakScript:changeState(4))
			)
			(case 4
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("Oh, dear! What a shame. The old bridge collapsed when you attempted to cross it. You have fallen to your death.")
				)
  				(send gGame:setScript(dyingScript))
			)
		)
	)
)
(instance brokenBoards of Act
	(properties
		x 253
		y 129
		view 25
	)
)
(instance egoFalling of Act
	(properties
		y 74
		view 27
	)
)
(instance egoFall of Act
	(properties
		view 30
		x 0
		y 0
		loop 6
		priority -1
	)
)
