/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 49)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(local
	falling = FALSE
)
/******************************************************************************/
(instance public rm049 of Rm
	(properties
		picture scriptNumber
		north 42
		east 0
		south 7
		west 48
		horizon 46
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (if (>= (send gEgo:x) 120)
					(send gEgo:
                   		posn(120 50) //x is remembered
                   		loop(2)
               		)
			   )(else
			   		(send gEgo:
			   			posn((send gEgo:x) 50)
			   			loop(2)
					)
				)
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (if (<= (send gEgo:y) 46)
                	(send gEgo:
                		posn(10 47)
                		loop(0)
					)
				)(else                
                	(send gEgo:
                    	posn(10 send gEgo:y) //y is remembered
                    	loop(0)
                	)
				 )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(self:setLocales(702))
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(<> falling TRUE)
			(if (== (send gEgo:onControl()) ctlYELLOW)
				(egoQuickFall:init()hide()x(send gEgo:x)y(send gEgo:y))
					(if(== (send gEgo:loop) 1)
						(egoQuickFall:setLoop(7))
					)(else
						(if(== (send gEgo:loop) 2)
							(egoQuickFall:setLoop(2))
						)
				 	)
				= falling TRUE				 
			)
		)(else
			(self:setScript(fallScript))
		 )
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance fallScript of Script
	(properties)
	(method (changeState cliffState)
	(var dyingScript)
		(= state cliffState)
		(switch (cliffState)
			(case 0 = cycles 1
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide())
				(egoQuickFall:
					show()
					ignoreActors()
					ignoreControl(ctlWHITE)
				)
			)
			(case 1
				(egoQuickFall:
					setCycle(End fallScript)
				)
			)
			(case 2
				(egoQuickFall:hide()dispose())
				(send gGame:setSpeed(6))
				Wait(180)
				ShakeScreen(20 ssUPDOWN)
				(self:cue())
			)
			(case 3
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("Whoops! You have fallen into the chasm, ending your quest.")
				)
  				(send gGame:setScript(dyingScript))
			)
		)
	)
)
(instance egoQuickFall of Act
	(properties
		view 30
		x 0
		y 0
		loop 6
		priority -1
	)
)