/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 51)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm051 of Rm
	(properties
		picture scriptNumber
		north 0
		east 52
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 98)  //y is remembered
                   loop(1)
				)
				PlayerControl()
				= gProgramControl FALSE
				(MenuBar:draw())
				(SL:enable())
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init()setCycle(StopWalk 14 14)setStep(4 4))
		(KingNeptune:init()setCycle(Fwd))
		(NeptuneFin:init())
		(if (== gKeyQuest 1)
			(if (== gNeptuneTrident 0)
				(KeyShell:init())
			)(else
				(KeyShell:init()setCel(3))
			 )
		)(else
			(KeyShell:init()setLoop(1))
		 )
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (Said('take>'))
			(if (Said('/key'))
				(if (== gNeptuneTrident 1)
					(if (== gKeyQuest 1)
						(if (<= (send gEgo:distanceTo(KeyShell)) 30)
							PrintOK()
							(KeyShell:setLoop(1))
							++gKeyQuest
							(send gGame:changeScore(5))
							(send gEgo:get(INV_GOLDKEY))
						)(else
							PrintNotCloseEnough()
					 	)
					)(else
						PrintAlreadyTookIt()
					 )
				)(else
					Print("What key?")
				 )
			)
		)
		(if (Said('give>'))
			(if (Said('/trident/neptune,king'))
				(if (== gNeptuneTrident 0)
					(if (send gEgo:has(INV_TRIDENT))
						(if (<= (send gEgo:distanceTo(KingNeptune)) 60)
							Print("Reverently, King Neptune accepts his lost trident from you. He gives you a bottle, then waves the trident in front of the huge clam, which opens and reveals . . . a large golden key!")
							(send gEgo:put(INV_TRIDENT)get(INV_BOTTLE))
							= gNeptuneTrident 1
							(send gGame:changeScore(4))
							(KingNeptune:setScript(NeptuneTrident))
						)(else
							PrintNotCloseEnough()
					 	)
					)(else
						Print("You don't have one to give to King Neptune.")
					 )
				)(else
					Print("You already gave it to him.")
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
				= cycles 1
			)
			(case 1
				(send gGame:setCursor(999 1))
			)
		)
	)
)
/******************************************************************************/
(instance NeptuneTrident of Script
	(properties)
	(method (changeState newState)
		(= state newState)
		(switch(newState)
			(case 0
				(KingNeptune:setLoop(2)setCycle(End NeptuneTrident))
			)
			(case 1
				(KeyShell:setCycle(End))
				(KingNeptune:setCycle(Beg NeptuneTrident))
			)
			(case 2
				(KingNeptune:setLoop(1)setCycle(Fwd))
			)
		)
	)
)
(instance KingNeptune of Prop
	(properties
		x 64
		y 112
		view 51
		cycleSpeed 3
	)
)
(instance NeptuneFin of Prop
	(properties
		x 78
		y 124
		view 51
		loop 3
	)
)
(instance KeyShell of Prop
	(properties
		x 31
		y 127
		view 52
		loop 0
		cycleSpeed 2
	)
)