/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 57)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "DPath")
/******************************************************************************/
(instance public rm057 of Rm
	(properties
		picture scriptNumber
		north 0
		east 58
		south 0
		west 56
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(Hole:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if (>= gPreviousRoomNumber 111 and <= gPreviousRoomNumber 117)
			SetCursor(999 HaveMouse())
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('ride>'))
			(if (Said('/carpet'))
				(self:setScript(CarpetScript))					
			)
		)
		(if(Said('look>'))
			(if(Said('/hole'))
				(if(<= (send gEgo:distanceTo(Hole)) 30)
					Print("Oh No! This is as bad as bad can be! Upon looking into the hole, you believe you see an incredibly blatant plug for another Sierra 3-D Animated Adventure. Hang On!")
					(send gRoom:newRoom(111))
				)(else
					Print("You're not quite close enough to see inside the hole.")
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Hole of Prop
	(properties
		x 121
		y 114
		view 59
	)
)
(instance EgoCarpet of Act
	(properties
		x 0
		y 0
		view 15
	)
)
(instance CarpetScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(newState)
			(case 0
				ProgramControl()
				= gProgramControl TRUE
				= gCarpetFlying TRUE
				(send gEgo:hide())
				(EgoCarpet:
					setStep(4 4)
					setPri(send gEgo:priority())
					init()
					ignoreControl(ctlWHITE)
					posn((send gEgo:x) (send gEgo:y))
					loop(1)
					setCycle(Fwd)
					setMotion(DPath (- (send gEgo:x) 10) 45 0 45 CarpetScript)
				)
			)
			(case 1
				(send gRoom:newRoom(56))
			)
		)
	)
)