/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 62)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm062 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 63
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(if(== gDraculaChestOpen FALSE)
			(Chest:init())
		)(else
			(Chest:init()setCel(3))
		 )
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('unlock / chest'))
			(if(== gChestLocked TRUE)
				(if(<= (send gEgo:distanceTo(Chest)) 30)
					(if(send gEgo:has(INV_SILVERKEY))
						Print("With hands trembling, you fit the little silver key into the lock. Slowly, you turn it until you hear a click. The old chest is now unlocked.")
						= gChestLocked FALSE
					)(else
						Print("You do not have the key that will unlock this chest.")
					 )
				)(else
					PrintNotCloseEnough()
				 )
			)(else
				Print("The aging chest is already unlocked.")
			 )
		)
		(if (Said('open>'))
			(if (Said('/chest'))
				(if (== gDraculaChestOpen FALSE)
					(if (<= (send gEgo:distanceTo(Chest)) 30)
						(if(== gChestLocked FALSE)
							(if(send gEgo:has(INV_TIARA))
								(Chest:setScript(chestScript))
								(chestScript:changeState(0))
							)(else
								(Chest:setScript(chestScript))
								(chestScript:changeState(3))
						 	)
						)(else
							Print("The old chest is locked shut. You need to unlock it.")
						 )
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintItIs()
				 )
			)
		)
		(if (Said('close>'))
			(if (Said('/chest'))
				(if (== gDraculaChestOpen TRUE)
					(if (<= (send gEgo:distanceTo(Chest)) 30)
						= gDraculaChestOpen FALSE
						(Chest:setCycle(Beg))
					)(else
						PrintNotCloseEnough()
					 )
				)(else
					PrintItIs()
				 )
			)
		)		
		(if(Said('get>'))
			(if (Said('/tiara'))
				(if (== gDraculaChestOpen 1)
					(if (not (send gEgo:has(INV_TIARA)))
						(if (<= (send gEgo:distanceTo(Chest)) 30)
							PrintOK()
							(send gEgo:get(INV_TIARA))
							(send gGame:changeScore(7))
						)(else
							PrintNotCloseEnough()
						 )
					)(else
						PrintAlreadyTookIt()
					 )
				)(else
					Print("You don't see that here.")
				 )
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Chest of Prop
	(properties
		x 239
		y 138
		view 40
		loop 0
		cel 0
	)
)
(instance chestScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(state)
			(case 0
				ProgramControl()
				= gProgramControl TRUE				
				= gDraculaChestOpen TRUE
				(Chest:setCycle(End chestScript))
			)
			(case 1 = cycles 3)
			(case 2
				Print("You open the heavy lid of the dusty old chest and peer into it.")				
				Print("It is empty.")
				PlayerControl()
				= gProgramControl FALSE
			)
			(case 3
				ProgramControl()
				= gProgramControl TRUE				
				= gDraculaChestOpen TRUE
				(Chest:setCycle(End chestScript))
			)
			(case 4 = cycles 3)
			(case 5
				Print("With a creak and a groan, the oil lid opens, dragging cobwebs with it.")
				Print("Looking into the interior of the musty chest, you see a dazzling diamond and saphire tiara!")
				PlayerControl()
				= gProgramControl FALSE
			)
		)
	)
)