/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 67)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Follow")
(use "DPath")
(local
	lDraculaTimer
	lDraculaActivate
	lTouchedEgo = FALSE
	lOutOfBed = FALSE
)
/******************************************************************************/
(instance public rm067 of Rm
	(properties
		picture scriptNumber
		north 0
		east 66
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case north
               (send gEgo:
                   posn((send gEgo:x) 60) //x is remembered
                   loop(2)
               )
            )
            (case east
                (send gEgo:
                   posn(310 send gEgo:y)  //y is remembered
                   loop(1)
               )
            )
            (case west
                (send gEgo:
                    posn(10 send gEgo:y) //y is remembered
                    loop(0)
                )
            )
            (case south
                (send gEgo:
                    posn((send gEgo:x) 180) //x is remembered
                    loop(3)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		
		(if(== gDraculaDead FALSE)
			= gCoffinOccupied Random(0 1)
			(if(== gCoffinOccupied TRUE)
				DraculaReset()
				(Coffin:init()setLoop(0)setCel(0))
				= gCoffinOpen FALSE
			)(else
				(Coffin:init()setLoop(1)setCel(3))
				= gCoffinOpen TRUE
			 )
		)(else
			= gCoffinOccupied FALSE
			(if(== gCoffinOpen TRUE)
				(Coffin:init()setLoop(1)setCel(3))
			)(else
				(Coffin:init()setLoop(1)setCel(0))
			 )
		 )
		
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		
		// If coffin is opened and occupied, the timer starts counting down
		(if(== lDraculaActivate TRUE and > lDraculaTimer 0 and == gCoffinOpen TRUE)
			--lDraculaTimer
		)
		// After timer countdown is complete, Dracula wakes up and exits coffin, chases player
		(if(== lDraculaActivate TRUE and == lDraculaTimer 0 and == gCoffinOpen TRUE)
			= lDraculaActivate FALSE
			Print("Count Dracula is awake! Run before it's too late!")
			(Coffin:setScript(wakeUpScript))
		)
		// Coffin is closed by Graham during countdown, timer stops counting down and resets
		(if((== lDraculaActivate TRUE) and (> lDraculaTimer 0) and (== gCoffinOpen FALSE))
			DraculaReset()
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('open>'))
			(if(Said('/coffin,box,lid'))
				(if(== (send gEgo:onControl()) ctlNAVY)
					(if(== gCoffinOpen FALSE)
						(if(== gCoffinOccupied TRUE)
							Print("With trepidation, you lift the heavy lid of the beautifully carved coffin. Your heart beats wildly when you see a vampire lying asleep within it! It must be Count Dracula!")
							(Coffin:setCycle(End))
							= gCoffinOpen TRUE
							= lDraculaActivate TRUE
						)(else
							Print("Nervously, you lift the heavy lid of the elegant coffin. You peek into its red satin interior. The coffin is unoccupied.")							
							(Coffin:setCycle(End))
							= gCoffinOpen TRUE
							(if(not send gEgo:has(INV_PILLOW))
								Print("A red satin pillow lies at one end.")
							)(else
								(if(not send gEgo:has(INV_GOLDKEY))
									Print("Against the red satin, you notice a large golden key!")
								)// end if doesn't have gold key
							 )// end if doesn't have pillow
						 )// end if coffin occupied
					)(else
						PrintItIs()
					 )// end if coffin open
				)(else
					PrintGetCloser()
				 )// end if close enough
			)// end open coffin
		)// end open
		(if(Said('close>'))
			(if(Said('/coffin,box,lid'))
				(if(== (send gEgo:onControl()) ctlNAVY)
					(if(== gCoffinOpen TRUE)
						(Coffin:setCycle(Beg))
						= gCoffinOpen FALSE
					)(else
						PrintItIs()
					 )// end if open
				)(else
					PrintGetCloser()
				 )// end if close enough
			)// end close coffin
		)// end close
		(if(Said('get>'))
			(if(Said('/dracula,count,man'))
				(if(== (send gEgo:onControl()) ctlNAVY)
					(if(== gCoffinOpen TRUE)
						(if(== gCoffinOccupied TRUE)
							Print("That is truly crazy.")
						)(else
							Print("You don't see him here.")
						 )// end if coffin occupied
					)(else
						Print("You don't see him here.")
					 )// end if coffin open
				)(else
					Print("You don't see him here.")
				 )// end if close enough
			)// end get man
			(if(Said('/pillow'))
				(if(== (send gEgo:onControl()) ctlNAVY)
					(if(== gCoffinOpen TRUE)
						(if(== gCoffinOccupied FALSE)
							(if(not send gEgo:has(INV_PILLOW))
								Print("You remove the shiny red pillow from the coffin. Lo and behold, a large gold key was underneath it!")
								(send gEgo:get(INV_PILLOW))
							)(else
								PrintAlreadyTookIt()
							 )// end if doesn't have pillow
						)(else
							Print("That was truly a dumb thing to do! Run before he catches you!")
						 )// end if coffin occupied
					)(else
						PrintDontSeeIt()
					 )// end if coffin open
				)(else
					(if(== gCoffinOpen TRUE)
						(if(not send gEgo:has(INV_PILLOW))
							PrintGetCloser()
						)(else
							PrintAlreadyTookIt()
						 )// end if doesn't have pillow
					)(else
						PrintDontSeeIt()
					 )// end if coffin open
				 )// end if close enough
			)// end get pillow
			
			(if(Said('/key<gold'))
				(if(not send gEgo:has(INV_GOLDKEY))
					(if(== gCoffinOpen TRUE)
						(if(== gCoffinOccupied FALSE)
							(if(send gEgo:has(INV_PILLOW))
								(if(== (send gEgo:onControl()) ctlNAVY)
									PrintOK()
									(send gEgo:get(INV_GOLDKEY))
									++gKeyQuest
									(send gGame:changeScore(5))
								)(else
									PrintNotCloseEnough()
								 )// end if close enough
							)(else
								PrintDontSeeIt()
							 )// end if has pillow
						)(else
							PrintDontSeeIt()
						 )// end if coffin occupied
					)(else
						PrintDontSeeIt()
					 )// end if coffin open
				)(else
					PrintAlreadyTookIt()
				 )// end if doesn't have gold key
			)// end get gold key
			(if(Said('/key<silver'))
				(if(not send gEgo:has(INV_SILVERKEY))
					(if(== gCoffinOpen TRUE)
						(if(== gCoffinOccupied FALSE)
							(if(== gDraculaDead TRUE)
								(if(== (send gEgo:onControl()) ctlNAVY)
									PrintOK()
									(send gEgo:get(INV_SILVERKEY))
									(send gGame:changeScore(2))
								)(else
									PrintNotCloseEnough()
								 )// end if close enough
							)(else
								PrintDontSeeIt()
							 )// end if dracula dead
						)(else
							PrintDontSeeIt()
						 )// end if coffin empty
					)(else
						PrintDontSeeIt()
					 )// end if coffin open
				)(else
					PrintAlreadyTookIt()
				 )// end if doesn't have silver key
			)// end get silver key
			(if(Said('/key'))
				(if(== gCoffinOpen TRUE)
					(if(== gCoffinOccupied FALSE)
						(if(== (send gEgo:onControl()) ctlNAVY)
							(if(not (send gEgo:has(INV_GOLDKEY)) and (send gEgo:has(INV_SILVERKEY)))
								(if(send gEgo:has(INV_PILLOW))
									PrintOK()
									(send gEgo:get(INV_GOLDKEY))
									++gKeyQuest
									(send gGame:changeScore(5))
								)(else
									PrintDontSeeIt()
								 )// end if has pillow
							)(else
								(if(not (send gEgo:has(INV_SILVERKEY)) and (send gEgo:has(INV_GOLDKEY)))
									(if(== gDraculaDead TRUE)
										PrintOK()
										(send gEgo:get(INV_SILVERKEY))
										(send gGame:changeScore(2))
									)(else
										PrintDontSeeIt()
									 )// end if dracula dead
								)(else
									(if(not (send gEgo:has(INV_SILVERKEY)) and not (send gEgo:has(INV_GOLDKEY)))
										(if(== gDraculaDead TRUE and (send gEgo:has(INV_PILLOW)))
											Print("There are two keys here. Do you want the gold key or the silver key?")
										)(else
											(if(== gDraculaDead TRUE and not (send gEgo:has(INV_PILLOW)))
												PrintOK()
												(send gEgo:get(INV_SILVERKEY))
												(send gGame:changeScore(2))
											)(else
												(if(== gDraculaDead FALSE and (send gEgo:has(INV_PILLOW)))
													PrintOK()
													(send gEgo:get(INV_GOLDKEY))
													++gKeyQuest
													(send gGame:changeScore(5))
												)(else
													PrintDontSeeIt()
												 )// end if dracula not dead and has pillow
											 )// end if dracula dead and doesn't have pillow
										 )// end if dracula dead and has pillow
									)(else
										PrintAlreadyTookIt()
									 )// end if doesn't have silver key or gold key
								 )// end if doesn't have silver key but has gold key
							 )// end if has silver key but not gold key
						)(else
					 		PrintGetCloser()
						 )// end if close enough
					)(else
						PrintDontSeeIt()
					 )// end if coffin occupied
				)(else
					PrintDontSeeIt()
				 )// end if coffin open
			)// end get key
		)// end get
		(if(Said('use>'))
			(if(Said('/stake,stick,mallet/man,dracula,count'))
				(if(== gDraculaDead FALSE)					
					(if(== gCoffinOpen TRUE)
						(if(== gCoffinOccupied TRUE)
							(if(== (send gEgo:onControl()) ctlNAVY)
								(if((send gEgo:has(INV_MALLET)) and (send gEgo:has(INV_STAKE)))
									(Coffin:setScript(killDraculaScript))
								)(else
									PrintDontHaveIt()
								 )// end if has mallet and stake
							)(else
								PrintGetCloser()
							 )// end if close enough
						)(else
							Print("You don't see him here.")
						 )// end if coffin occupied
					)(else
						Print("You don't see him here.")
				 	)// end if coffin open
				)(else
					Print("You've already killed him. He'll never bother anybody again.")
				 )// end if dracula not dead
			)// end use stake with man
			(if(Said('/sword/man,dracula,count'))
				(if(== gDraculaDead FALSE)					
					(if(== gCoffinOpen TRUE)
						(if(== gCoffinOccupied TRUE)
							(if(== (send gEgo:onControl()) ctlNAVY)
								(if(send gEgo:has(INV_SWORD))
									Print("You plunge the sword into Count Dracula's sleeping body. Oh, dear! It has no effect. You just woke him up.")
									(Coffin:setScript(wakeUpScript))
								)(else
									PrintDontHaveIt()
								 )// end if has sword
							)(else
								PrintGetCloser()
							 )// end if close enough
						)(else
							Print("You don't see him here.")
						 )// end if coffin occupied
					)(else
						Print("You don't see him here.")
				 	)// end if coffin open
				)(else
					Print("You've already killed him. He'll never bother anybody again.")
				 )// end if dracula not dead
			)// end use sword with man
		)// end use
		(if(Said('kill/dracula,count,man'))
			(if(== gDraculaDead FALSE)					
				(if(== gCoffinOpen TRUE)
					(if(== gCoffinOccupied TRUE)
						(if(== (send gEgo:onControl()) ctlNAVY)
							(if((send gEgo:has(INV_MALLET)) and (send gEgo:has(INV_STAKE)))
								(Coffin:setScript(killDraculaScript))
							)(else
								(if(send gEgo:has(INV_SWORD))
									Print("You plunge the sword into Count Dracula's sleeping body. Oh, dear! It has no effect. You just woke him up.")
									(Coffin:setScript(wakeUpScript))
								)(else
									Print("You have no way of killing Count Dracula. You are in mortal danger!")
								 )// end if has sword
							 )// end if has mallet and stake
						)(else
							PrintGetCloser()
						 )// end if close enough
					)(else
						Print("You don't see him here.")
					 )// end if coffin occupied
				)(else
					Print("You don't see him here.")
			 	)//end if coffin open
			)(else
				Print("You've already killed him. He'll never bother anybody again.")
			 )// end if dracula not dead
		)// end kill man
	)// end handleEvent

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
		)
	)
)
/******************************************************************************/
(instance Coffin of Prop
	(properties
		x 157
		y 120
		view 32
		z 16
		loop 0
		cel 0
	)
)
(instance Dracula of Act
	(properties
		x 155
		y 125
		view 33
	)
)
(instance wakeUpScript of Script	// Dracula wakes up script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(state)
			(case 0					// animation of Dracula waking up in coffin
				DraculaReset()
				(Coffin:
					setLoop(2)
					setCel(0)
					setCycle(End wakeUpScript)
				)
			)
			(case 1 				// Dracula exits coffin and chases Graham
				= gCoffinOccupied FALSE
				= lOutOfBed TRUE
				(Coffin:
					setLoop(1)
					setCel(3)
				)				
				(Dracula:
					init()
					setStep(5 5)
					setCycle(Walk)
					setMotion(Follow gEgo 10)
				)
			)
		)
	)
	(method (doit)					// if Dracula touches Graham, the Dracula-kills-Graham script is executed
		(super:doit())
		(if(<= send gEgo:distanceTo(Dracula) 11 and == lTouchedEgo FALSE and == lOutOfBed TRUE)
			= lTouchedEgo TRUE
			(Dracula:setScript(draculaKill))
		)
	)
)
(instance draculaKill of Script		// Dracula kills Graham script
	(properties)
	(method (changeState newState)
	(var dyingScript)
		= state newState
		(switch(state)
			(case 0 = cycles 1
				ProgramControl()
				= gProgramControl TRUE
				Print("You are caught in Dracula's grasp! Saliva drips off the end of his sharp fangs!")
			)
			(case 1
				(if(== gWearingCross TRUE)
					Print("Suddenly, he is aware of the silver cross you are wearing around your neck!")
					Print("Count Dracula is terrified of the cross. He turns into a bat and flies away.")
					(draculaKill:changeState(5))
				)(else
					(draculaKill:changeState(2))
				 )
			)
			(case 2					// Dracula kills Graham
				(send gEgo:hide())
				(Dracula:
					view(35)
					setCel(0)
					setCycle(End draculaKill)
				)
			)
			(case 3 = cycles 5
				Print("You feel them sink into the soft flesh of your neck, and then ...nothing.")
			)
			(case 4
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("Next time, don't get yourself into a dangerous situation without protection!")
				)
  				(send gGame:setScript(dyingScript))
			)
			(case 5					// Dracula flees at sight of cross
				PlayerControl()
				= gProgramControl FALSE
				(Dracula:
					view(34)
					z(15)
					ignoreActors()
					cycleSpeed(0)
					setStep(7 7)
					setCycle(Fwd)
					setMotion(
						DPath
						263 139
						319 139
						draculaKill
							 )
				)// end Dracula Act				
			)
			(case 6
				(Dracula:dispose())
			)
		)// end switch
	)// end method
)// end instance
(instance killDraculaScript of Script	// Graham kills Dracula script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(state)
			(case 0 
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide())
				(Coffin:
					setLoop(3)
					setCel(0)
					setCycle(End killDraculaScript)
				)
			)
			(case 1 = cycles 20
				(Coffin:setCycle(Fwd))
			)
			(case 2
				(Coffin:setCycle(End killDraculaScript))
				
			)
			(case 3				
				Print("You place the pointed stake on Count Dracula's chest. Quickly, using the mallet, you pound the stake through his heart. Dracula disintegrates into a pile of dust. A small silver key is left behind in the coffin.")
				(send gEgo:show())
				(Coffin:setLoop(1)setCel(3))
				PlayerControl()
				= gProgramControl FALSE
				(send gGame:changeScore(7))
				= gCoffinOccupied FALSE
				= gDraculaDead TRUE
				DraculaReset()
			)
		)
	)
)
(procedure (DraculaReset)
	= lDraculaTimer Random(50 100)
	= lDraculaActivate FALSE
)