/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 68)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
/******************************************************************************/
(instance public rm068 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 20
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(56 127)
					loop(0)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
		(Lady:init()setCycle(Fwd))
		(Lamp:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('talk>'))
			(if (Said('/lady'))
				Print("That old oil lamp on the table is a new item in my shop. I think it may interest you."
					#width 140
					#title "Antique Lady"
					#at 135 19
					#dispose 
					)
			)
		)
		(if(Said('take>'))
			(if(Said('/lamp'))
				Print("You can't just take the lamp. You have to buy it.")
			)
		)
		(if(Said('buy>'))
			(if(Said('/lamp'))
				Print("The oil lamp is expensive. It will cost you two treasures. There is an alternative, though. The old hag, Hagatha, stole my precious nightingale. If you can return it to me, then I will give you the oil lamp."
					  #width 243
					  #title "Antique Lady"
					  #at 55 19
					  #dispose 
					 )
			)
		)
		(if(Said('give>'))
			(if(Said('/nightingale,cage/lady'))
				(if (send gEgo:has(INV_NIGHTINGALE))
					(send gEgo:put(INV_NIGHTINGALE)get(INV_LAMP))
					= gAntiqueBird TRUE
					Print("My precious nightingale! Thank you for returning it, kind sir! In gratitude for your selfless deed you may have the oil lamp. Now I must close up shop. Once again please accept my sincere thanks and good luck!"
						#title "Antique Lady"
						#width 243
						#at 55 19
						#dispose 
						 )
					(RoomScript:changeState(2))
				)(else
					Print("You don't have a nightingale to give to the antique lady.")
				 )
			)
		)
	)
	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0 = cycles 1
				// Handle state changes
			)
			(case 1
				Print("How may I help you?"
					#mode alCENTER
					#width 105
					#time 4
					#title "Antique Lady"
					#at 152 23	
					#dispose 				
					)
			)
			(case 2
				= cycles 50
				(Lamp:dispose())
			)
			(case 3
				(send gRoom:newRoom(20))
			)
		)
	)
)
/******************************************************************************/
(instance Lady of Prop
	(properties
		x 237
		y 128
		view 53
		cycleSpeed 2
	)
)
(instance Lamp of Prop
	(properties
		x 107
		y 159
		view 54
	)
)