/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 70)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Follow")
(local
	GrandmaOrWolf	
)
/******************************************************************************/
(instance public rm070 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 3
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(33 180)
					loop(3)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
		= GrandmaOrWolf Random(1 3)
		(if (<> GrandmaOrWolf 3)
			(GrandmaWolf:init()loop(1))
			Print("Oh dear! A wolf in grandma's clothing is in the bed! Get out of here, fast!")
			(RoomScript:changeState(1))
		)(else
			(GrandmaWolf:init()loop(0))
		 )
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(== GrandmaWolf:view() 61)
			(if(<= send gEgo:distanceTo(GrandmaWolf) 15)
				= gProgramControl TRUE
				ProgramControl()
				(RoomScript:changeState(6))
			)
		)
	)
	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('give/soup'))
			(if (== GrandmaOrWolf 3)
				(if(send gEgo:has(INV_SOUP))
					(if(<= (send gEgo:distanceTo(GrandmaWolf)) 20)
						Print("You feed the hot chicken soup to ailing Grandma. \"I feel much better,\" she says. \"In return for your kindness, I have something for you. Look under the bed.\"")						
						= gCanLookUnderBed TRUE
					)(else
						PrintNotCloseEnough()
				 	)
				)(else
					PrintDontHaveIt()
				 )
			)(else
				Print("She's not here!")
			)
		)
		(if(Said('look<under/bed'))
			(if (<= send gEgo:distanceTo(GrandmaWolf) 20)
				(if (gCanLookUnderBed)
					(if(not (send gEgo:has(INV_CLOAK)) and not (send gEgo:has(INV_RING)))
						Print("You drop to your hands and knees and peer under the bed. A large ruby ring and a black cloak are hidden there. You take them into your possession.")
						(send gEgo:get(INV_CLOAK))
						(send gEgo:get(INV_RING))
						(send gGame:changeScore(4))
					)(else
						Print("You peek under the bed but see only dust.")
					 )
				)(else
					Print("It would not be polite to do that.")
				 )
			)(else
				PrintNotCloseEnough()
			 )
		)
	)

	(method (changeState newState)
	(var dyingScript)
		(= state newState)		
		(switch (newState)
			(case 0
				// Handle state changes
			)
			(case 1
				= cycles 5
			)
			(case 2 = cycles 5
				(GrandmaWolf:
					posn(77 122)
					view(61)
					loop(0)
				)
			)
			(case 3
				(GrandmaWolf:
					setCycle(Walk)
					loop(2)
					setStep(5 5)					
					setMotion(Follow gEgo 15)
				)
			)			
			(case 4 = cycles 40
				
			)
			(case 6
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("The wolf pounces on you! My, what big TEETH he has! Good enough to eat you with, my dear.")
				)
  				(send gGame:setScript(dyingScript))
			)
		)
	)
)
/******************************************************************************/
(instance GrandmaWolf of Act
	(properties
		x 63
		y 104
		view 60
		cycleSpeed 0
		moveSpeed 0
	)
)
(instance EgoDead of Prop
	(properties
		x 0
		y 0
		view 16
		loop 1
	)
)
(instance Smoke of Act
	(properties
		x 0
		y 0
		view 62
		loop 0
	)
)