/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 71)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Avoid")
(local
	MonkPraying = TRUE
	Bowing
)
/******************************************************************************/
(instance public rm071 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 6
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(160 185)
					loop(3)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init())
		(Monk:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('yell/monk'))
			(if(== MonkPraying TRUE)
				Print("You shout at the praying monk. He pays no attention. The monk is deep in prayer.")
			)(else
				Print("You don't need to yell at the monk. You already have his attention.")
			 )
		)
		(if(Said('talk/monk'))
			(if(== MonkPraying FALSE)
				Print("Can I be of service? What name do you go by?"
					#title "Monk"
					#at 26 15
					#time 4					
					 )
			)(else
				Print("You speak to the praying monk but he does not respond. He seems deep in worship.")
			 )
		)
		(if(Said('look>'))
			(if(Said('/monk'))
				Print("The monk is dressed in a simple ankle-length robe. A belt of thin leather is tied around his ample waist. He walks on worn sandals.")
			)
			(if(Said('/cross'))
				Print("The wooden cross is plain and simple. An altar of polished oak supports it.")
			)
			(if(Said('/altar'))
				Print("There is a large wooden cross atop the oaken altar.")
			)
			(if(Said('[/around,chapel]'))
				(if(== MonkPraying TRUE)
					(if(not (send gEgo:has(INV_CROSS)))
						Print("The chapel of the monastery is plain and unadorned. Rows of pews lead toward an altar, which is topped by a large cross.")
				   	)(else
				   			Print("The chapel of the monastery is plain and unadorned. A monk in simple clothing is bent in prayer toward the cross on the altar.")
						)
				)(else
					Print("The chapel of the monastery is plain and unadorned. A monk in simple clothing is standing next to the altar. He looks kindly at you.")
				 )
			)
		)
		(if(Said('pray[/*]'))
			(if(send gEgo:inRect(142 90 197 110))
				(if(not (send gEgo:has(INV_CROSS)))
					(send gGame:changeScoreSilent(2))
				)
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:setAvoider(Avoid)setMotion(MoveTo 173 91 RoomScript))
			)(else
				Print("Shouldn't you go to the altar to pray?")
			 )
		)
		(if(Said('bow[/*]'))
			(if(send gEgo:inRect(142 90 197 110))
				= Bowing TRUE
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:setAvoider(Avoid)setMotion(MoveTo 173 91 RoomScript))
			)(else
				Print("Come join me at the altar, my friend."
					#title "Monk"
					#at 26 15
					#time 4
					)
			 )
		)
		(if(Said('graham') or (Said('my/name/graham')))
			(if(== MonkPraying FALSE)
				(if(<= (send gEgo:distanceTo(Monk)) 45)
					Print("I have heard of you and your quest, King Graham. Here, take my cross. It will protect you from evil."
						#title "Monk"
						#at 26 15
						#time 6
						)
					Print("He removes a chain with a silver cross from around his neck and gives it to you. The monk then resumes his prayers.")
					Print("Go in peace, King Graham."
						#title "Monk"
						#at 26 15
						#time 3
						)
					(send gEgo:get(INV_CROSS))
					(send gGame:changeScore(2))
					(RoomScript:cue())
				)(else
					Print("You'll have to move closer if you want the monk to hear you, King Graham.")
				 )
			)(else
				Print("You blurt your name out for no good reason. Luckily the monk is too engrossed in prayer to notice anything else, saving you the embarrassment.")
			 )
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
			)
			(case 1
				(if(== Bowing TRUE)
					Print("You kneel near the altar. You look up at the wooden cross.")
				)(else
					Print("You kneel near the altar. Bowing your head, you pray.")
				 )
				(send gEgo:hide()loop(3))				
				(EgoKneel:init()setCycle(End RoomScript))
			)
			(case 2
				= cycles 40				
			)
			(case 3
				(EgoKneel:setCycle(Beg RoomScript))
			)
			(case 4 = cycles 1
				(EgoKneel:dispose())
				(send gEgo:show()loop(3))
				(if(not (send gEgo:has(INV_CROSS)) and == Bowing FALSE)
						Print("The plump monk lifts his head from prayer and seems to notice you for the first time. He stands and speaks to you.")
				)
			)
			(case 5
				(if(not (send gEgo:has(INV_CROSS)) and == Bowing FALSE)
					(Monk:setCycle(End RoomScript))					
				)(else
					= Bowing FALSE
					PlayerControl()
					= gProgramControl FALSE
					(RoomScript:changeState(0))
				)
			)
			(case 6
				Print("Can I be of service? What name do you go by?"
					#title "Monk"
					#at 26 15
					#time 4
					)
				= MonkPraying FALSE
				PlayerControl()
				= gProgramControl FALSE
			)
			(case 7
				= MonkPraying TRUE
				(Monk:setCycle(Beg RoomScript))
			)
			(case 8
				(RoomScript:changeState(0))
			)
		)
	)
)
/******************************************************************************/
(instance Monk of Act
	(properties
		x 142
		y 92
		view 63
	)
)
(instance EgoKneel of Act
	(properties
		x 173
		y 91
		view 17
	)
)
