/******************************************************************************
 King's Quest II SCI Remake
 By Brandon Blume
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 91)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(local
	lLionRoaring = FALSE
	lLionRoar
	lFedLion = FALSE
	lDying = FALSE
)
/******************************************************************************/
(instance public rm091 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 92
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(case 90
               (send gEgo:
                   posn(183 140) //x is remembered
                   loop(2)
               )
            )            
            (default
                (send gEgo:
                    posn(130 180) //x is remembered
                    loop(1)
                )
            )
		)
		
		SetUpEgo()
		(send gEgo:init())
		(switch(gLionState)
			(case 0
				(aLion:init())				
			)
			(case 1
				(aLion:init()setLoop(3)setCycle(Fwd)cycleSpeed(3))
			)
			(case 2
				(aLion:init()setLoop(4))
			)
		)
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)

	(method (doit)
		(super:doit())
		// code executed each game cycle
		(if(== gLionState 0 and == lLionRoaring FALSE)
			(aLion:setScript(lionRoarScript))
		)
		(if(== (send gEgo:onControl()) ctlNAVY and <> gLionState 0)
			(send gRoom:newRoom(90))
		)
		(if((== (send gEgo:onControl()) ctlGREEN or == (send gEgo:onControl()) ctlNAVY) and == gLionState 0 and == lDying FALSE)
			= lDying TRUE
			(aLion:setScript(lionKillScript))
		)
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if(Said('look>'))
			(if(Said('/lion'))
				(switch(gLionState)
					(case 0
						Print("This is the BIGGEST lion you have ever seen! He could eat you with two bites of his powerful jaws. His tail thumps repeatedly on the floor.")
					)
					(case 1
						Print("The lion is sound asleep.")
					)
					(case 2
						Print("The large lion has succumbed from the blow of your sword. He is dead.")
					)
				)
			)
		)
		(if(Said('feed/lion'))
			(switch(gLionState)
				(case 0
					(if(send gEgo:has(INV_HAM))						
						(aLion:setScript(lionEatScript))
					)(else
						Print("You don't have anything to feed to the lion.")
			 		)
				)
				(case 1
					Print("The lion is sound asleep.")
				)
				(case 2
					Print("The large lion has succumbed from the blow of your sword. He is dead.")
				)
			)
		)
		(if(Said('give>'))
			(if(Said('/ham/lion'))
				(switch(gLionState)
					(case 0
						(if(send gEgo:has(INV_HAM))
							(aLion:setScript(lionEatScript))
						)(else
							Print("You don't have anything to feed to the lion.")
			 			)
					)
					(case 1
						Print("The lion is sound asleep.")
					)
					(case 2
						Print("The large lion has succumbed from the blow of your sword. He is dead.")
					)
				)
			)
		)
		(if(Said('throw>'))
			(if(Said('/sword'))
				Print("Swords don't fly very well. Think again.")
			)
			(if(Said('/ham[/lion]'))
				(switch(gLionState)
					(case 0
						(if(send gEgo:has(INV_HAM))
							(aLion:setScript(lionEatScript))
						)(else
							Print("You don't have anything to feed to the lion.")
			 			)
					)
					(case 1
						Print("The lion is sound asleep.")
					)
					(case 2
						Print("The large lion has succumbed from the blow of your sword. He is dead.")
					)
				)		 	
			)
		)
		(if(Said('use>'))
			(if(Said('/sword/lion'))
				(switch(gLionState)
					(case 0
						(if(& (send gEgo:onControl()) ctlTEAL)
							Print("With one mighty heave of your sword, you fatally wound the large lion. He slumps to the floor.")
							(send gGame:changeScore(2))
							(send gEgo:put(INV_SWORD))
							(aLion:init()setLoop(4))
							= gLionState 2
						)(else
							PrintNotCloseEnough()
						 )
					)
					(case 1
						(if(& (send gEgo:onControl()) ctlTEAL or == (send gEgo:onControl()) ctlGREEN)
							Print("With one mighty heave of your sword, you fatally wound the large lion. He slumps to the floor.")
							(send gGame:changeScore(-3))
							(send gEgo:put(INV_SWORD))
							(aLion:init()setLoop(4))
							= gLionState 2
						)(else
							PrintNotCloseEnough()
						 )
					)
					(case 2
						Print("The large lion has succumbed from the blow of your sword. He is dead.")
					)
				)				
			)
		)
		(if(Said('kill/lion[/sword]'))
			(switch(gLionState)
				(case 0
					(if(& (send gEgo:onControl()) ctlTEAL)
						Print("With one mighty heave of your sword, you fatally wound the large lion. He slumps to the floor.")
						(send gGame:changeScore(2))
							(send gEgo:put(INV_SWORD))
							(aLion:init()setLoop(4))
							= gLionState 2
					)(else
						PrintNotCloseEnough()
					 )
				)
				(case 1
					(if(& (send gEgo:onControl()) ctlTEAL or == (send gEgo:onControl()) ctlGREEN)
						Print("With one mighty heave of your sword, you fatally wound the large lion. He slumps to the floor.")
						(send gGame:changeScore(-3))
							(send gEgo:put(INV_SWORD))
							(aLion:init()setLoop(4))
							= gLionState 2
					)(else
						PrintNotCloseEnough()
					 )
				)
				(case 2
					Print("The large lion has succumbed from the blow of your sword. He is dead.")
				)
			)
		)
	)

	(method (changeState newState)
		(= state newState)
		(switch (newState)
			(case 0
				// Handle state changes
				(if(== gLionState 0)
					= cycles 5
					(aLion:setCycle(End))
				)
			)
			(case 1
				Print("Be careful!!! There is a huge lion with dripping fangs at the top of the stairs. He has a hungry look in his eye!")
			)
		)
	)
)
/******************************************************************************/
(instance aLion of Prop
	(properties
		x 205
		y 157
		view 68
	)
)
(instance lionRoarScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(state)
			(case 0
				= lLionRoaring TRUE
				= lLionRoar Random(0 10)
				(if(<= lLionRoar 2)
					(aLion:
						setCel(0)
						setCycle(End lionRoarScript)
					)
				)
			)
			(case 1
				= lLionRoaring FALSE
				(aLion:
					setCycle(Beg)
				)
			)
		)
	)
)
(instance lionEatScript of Script
	(properties)
	(method (changeState newState)
		= state newState
		(switch(state)
			(case 0 = cycles 15
				Print("Hungrily, the lion gobbles down the smoked ham and then falls fast asleep.")
				(send gEgo:put(INV_HAM))
				(send gGame:changeScore(4))
				= lFedLion TRUE
				= gLionState 1
				(aLion:
					setLoop(2)
					setCycle(Fwd)
					cycleSpeed(1)
				)
			)
			(case 1
				(aLion:
					setLoop(3)
					setCycle(Fwd)
					cycleSpeed(3)
				)
			)
		)
	)
)
(instance lionKillScript of Script
	(properties)
	(method (changeState newState)
	(var dyingScript)
		= state newState
		(switch(state)
			(case 0
				ProgramControl()
				= gProgramControl TRUE
				(send gEgo:hide())
				(aLion:
					setLoop(1)
					setCel(0)
					setCycle(End lionKillScript)
					cycleSpeed(1)
				)
			)
			(case 1
				= dyingScript ScriptID(DYING_SCRIPT)
 				(send dyingScript:
    				caller(699)
    				register("CRUNCH! SNARL! CHOMP! Well, you made a nice meal for the hungry lion! SMACK! SLURP!")
				)
  				(send gGame:setScript(dyingScript))
			)
		)
	)
)