/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script INTRO_SCRIPT)
/******************************************************************************/
(use "Controls")
(use "Cycle")
(use "Door")
(use "Feature")
(use "Game")
(use "Inv")
(use "Main")
(use "Obj")
(use "Window")
/******************************************************************************/
(instance public rm104 of Rm
	(properties
		picture 104
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(send gGame:setSpeed(6))
		(super:init())
		(self:setScript(RoomScript))
		
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(52 140)
					loop(0)
				)
			)
		)
		
		SetUpEgo()
		(send gEgo:init()hide())
		(SitStand:init())
		(Mirror:init())
		(theHat:init())
		(Stand:init())
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
	(method (changeState newState)
//		(var yStart, xStart, yFinish, xFinish, w, h, w2, h2, x, y, hCenter, vCenter)
		= state newState
		(switch(state)
			(case 0 
				(= cycles 1)
			)
			(case 1 = cycles 5
				(send gGame:setCursor(997 0))
				ProgramControl()
				= gProgramControl TRUE
			)
			(case 2 = cycles 40
				(TextWindow:
					setdim(235 42)
					hcenter(143)
					open()
					displaygui(104 0)
				)
			)
			(case 3 = cycles 5
				(TextWindow:dispose())
			)
			(case 4 = cycles 40
				(TextWindow:
					setdim(235 42)
					hcenter(143)
					open()
					displaygui(104 1)
				)
			)
			(case 5 = cycles 5
				(TextWindow:dispose())
			)
			(case 6 = cycles 30
				(TextWindow:
					setdim(235 34)
					hcenter(149)
					open()
					displaygui(104 2)
				)
			)
			(case 7 = cycles 10
				(TextWindow:dispose())
				(SitStand:setCycle(End))
			)
			(case 8 = cycles 20
				(TextWindow:
					setdim(235 34)
					hcenter(149)
					open()
					displaygui(104 3)
				)
				(SitStand:hide())
				(crownEgo:init()setCycle(StopWalk 6 7)setMotion(MoveTo 142 126))
			)
			(case 9 = cycles 11
				(crownEgo:setCycle(StopWalk 6 7)loop(3)setMotion(MoveTo 154 103))
			)
			(case 10 = cycles 1
				(crownEgo:setCycle(StopWalk 6 7)loop(3))
			)
			(case 11 = cycles 40				
				(Mirror:loop(1)setCycle(Fwd))
			)
			(case 12 = cycles 5
				(TextWindow:dispose())
			)
			(case 13
				(send gRoom:newRoom(107))
			)
		)
	)
	(method (doit)
		(super:doit())
		// code executed each game cycle
	)

	(method (handleEvent pEvent)
		(super:handleEvent(pEvent))
		// handle Said's, etc...
		(if (== (send pEvent:type) evKEYBOARD)
           	(if (== (send pEvent:message) KEY_ESCAPE)
				(if (not (TextWindow:dispose()))
					(TextWindow:dispose())
					ProgramControl()
					= gProgramControl FALSE
					(send gRoom:newRoom(TITLESCREEN_SCRIPT))
				)(else
					ProgramControl()
					= gProgramControl FALSE
					(send gRoom:newRoom(TITLESCREEN_SCRIPT))
				 )
			)(else
				(if (== (send pEvent:message) KEY_RETURN)
					(if (not (TextWindow:dispose()))
						(TextWindow:dispose())
						ProgramControl()
						= gProgramControl FALSE
						(send gRoom:newRoom(TITLESCREEN_SCRIPT))
					)(else
						ProgramControl()
						= gProgramControl FALSE
						(send gRoom:newRoom(TITLESCREEN_SCRIPT))
					 )
				)
			 )
		)	
		(if(== (send pEvent:type()) evMOUSEBUTTON)
			(if (not (TextWindow:dispose()))
				(TextWindow:dispose())
				ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			)(else
				ProgramControl()
				= gProgramControl FALSE
				(send gRoom:newRoom(TITLESCREEN_SCRIPT))
			 )
		)
	)
)
/******************************************************************************/
(instance shimmerScript of Script
    (properties)
    (method (changeState newState)
        = state newState
        (switch (state)
            (case 1
                 (Mirror:setCycle(End shimmerScript))
            )(case 2
                 (Mirror:setCycle(Beg shimmerScript)) 
            )(case 3
                 (shimmerScript:changeState(1)) // make it all loop around forever!
			 )
		)
	)
)
(instance SitStand of Act
	(properties
		x 83
		y 117
		view 9
		cycleSpeed 1
	)
)
(instance crownEgo of Act
	(properties
		x 83
		y 117
		view 6
	)
)
(instance Mirror of Prop
	(properties
		x 158
		y 46
		view 10
		loop 0
		cel 0
	)
)
(instance theHat of Prop
	(properties
		x 52
		y 137
		z 24
		view 11
		loop 1
		cel 0
	)
)
(instance Stand of Prop
	(properties
		x 52
		y 137
		view 11
		loop 0
		cel 0
	)
)